FUNCTION coo2co,proj

;+
; NAME:
;	coo2co
; PURPOSE:
;	Converts fits-like coordinates description to COBE-like
;    (e.g. 'RA' into 'q')
; CALLING SEQUENCE:
;	res=coo2co(proj)
; INPUTS:
;	proj : Fits-like projection type, ie 'RA', 'GLON' or 'ECLON'
; OUTPUTS
;	res  : Dirbe-like projection type, ie 'q','g','e'
; RESTRICTIONS:
;	None
; REVISION HISTORY:
;	Bernard J.P., a long time ago
;-

routine='coo2co'

IF N_params() EQ 0 THEN BEGIN
  auto_help,routine,/is_function
  goto,sortie
ENDIF

CASE proj OF

'GLON':co='g' 
'ELON':co='e' 
'RA':co='q'

ENDCASE

RETURN,co
sortie:

END
