FUNCTION pix_in_map2,fits_header,phi,theta,pixx,pixy,within=within

;decides if given pixels are inside the map described by fits_header
;within a margin given by within (in degrees)

message,'Entering pixinmap',/info

naxis1=sxpar(fits_header,'NAXIS1')
naxis2=sxpar(fits_header,'NAXIS2')

Npix=(size(pixx))(1)
is_in_map=bytarr(Npix)

ind=where(pixx GE 0 AND pixx LE (Naxis1-1) AND pixy GE 0 AND pixy LE (Naxis2-1),count)
;stop
IF count NE 0 THEN BEGIN
  is_in_map(ind)=1
ENDIF

IF keyword_set(within) THEN BEGIN
  h2pix,fits_header,/silent
  ind=where(is_in_map NE 1,count)
  IF count NE 0 THEN BEGIN
    pix2coo2,pixx(ind),pixy(ind),c1,c2,phi0,theta0,/silent
    c1=0 & c2=0
    FOR i=0L,count-1 DO BEGIN
      ind1=where(abs(phi-phi0(i)) LE 2.*within/cos(theta0(i)/!radeg) AND abs(theta-theta0(i)) LE 2.*within and $
          phi NE !indef and theta NE !indef, count1)
      IF count1 NE 0 THEN is_in_map(ind(i))=1
    ENDFOR
  ENDIF
ENDIF

message,'Leaving pixinmap',/info

RETURN,is_in_map

END