FUNCTION scale_header_naxis,hh,fact

;scales a fits header by some factor
;the number of pixels (naxis) is scaled by fact
;the pixel size is scaled by 1/fact accordingly
;so that the sky area covered is unchanged.

h=hh

;scales the header by some factor
cdelt1=sxpar(h,'CDELT1') & cdelt2=sxpar(h,'CDELT2')
naxis1=sxpar(h,'NAXIS1') & naxis2=sxpar(h,'NAXIS2')
crpix1=sxpar(h,'CRPIX1') & crpix2=sxpar(h,'CRPIX2')

lon_range=cdelt1*naxis1 & lat_range=cdelt2*naxis2
ff1=(1.*crpix1)/(1.*naxis1) & ff2=(1.*crpix2)/(1.*naxis2)

new_naxis1=long(naxis1*fact) & new_naxis2=long(naxis2*fact)
new_cdelt1=lon_range/(1.*new_naxis1) & new_cdelt2=lat_range/(1.*new_naxis2)
new_crpix1=new_naxis1*ff1 & new_crpix2=new_naxis2*ff2

sxaddpar,h,'CDELT1',new_cdelt1 & sxaddpar,h,'CDELT2',new_cdelt2
sxaddpar,h,'NAXIS1',new_naxis1 & sxaddpar,h,'NAXIS2',new_naxis2
sxaddpar,h,'CRPIX1',new_crpix1 & sxaddpar,h,'CRPIX2',new_crpix2

RETURN,h

END
