PRO sph_fourth_pos,clon1,slon1,clat1,slat1,dist1, $
                   clon2,slon2,clat2,slat2,dist2, $
                   clon3,slon3,clat3,slat3,dist3, $
                   lon,lat

;Computes the sky coordinates of a point, given its angular distance
;to 3 other points of known coordinates
;dist1,dist2,dist3 are cosines of the angular distance
;clon#,slon#,clat#,slat# are cosines and sines of longitudes and
;latitudes respectively. They must be 1-D arrays

;clon1=cos([lon1]) & slon1=sin([lon1]) & clat1=cos([lat1]) & slat1=sin([lat1])
;clon2=cos([lon2]) & slon2=sin([lon2]) & clat2=cos([lat2]) & slat2=sin([lat2])
;clon3=cos([lon3]) & slon3=sin([lon3]) & clat3=cos([lat3]) & slat3=sin([lat3])

alpha=1.d0*[[dist1],[dist2],[dist3]]
Nvec=n_elements(clon1)

lon=dblarr(Nvec) & lat=dblarr(Nvec)
FOR i=0L,Nvec-1 DO BEGIN
;  stop
  mat=1.d0*[[clat1(i)*clon1(i),clat1(i)*slon1(i),slat1(i)], $
            [clat2(i)*clon2(i),clat2(i)*slon2(i),slat2(i)], $
            [clat3(i)*clon3(i),clat3(i)*slon3(i),slat3(i)]]
  abc=invert(mat)##alpha
  lat(i)=asin(abc(2))
  clat=cos(lat(i))
  lon(i)=atan(abc(1)/clat,abc(0)/clat)
ENDFOR

END
