PRO cube_l_b_r,bidon

;---------------------------------------------------------
; cube_l_b_r.PRO
;
; a partir de l'image data_cube (le cube hi toutes vitesses)
; 	--> '/net/srvr/pb1/mamd/datatoutevit.idl'
; on fabrique un cube (l, b, R).
;
; On tient compte des differentes valeurs de vitesse:
;	v < vmin : gaz de la zone C (lointain). On le place
;		arbitrairement dans R=R0 car il est impossible
;		de lui attribuer un rayon (je crois). Dans notre
;		cas ca ne change rien puisqu'on est interesse a
;		soustraire cette composante (on soustrait toujours
;		le gaz a R0 puisqu'on regarde le gaz dans l'a.m.).
;	vmin < v < vmax: gaz traite normalement avec la courbe de
;		rotation.
;	v > vmax : On ramene le gaz au point tangent (v=vmax).
;
; Le cube resultant est dans hi_l_b_r.idl
;
; MAMD 11/10/96
;-----------------------------------------------------------


; DEFINITIONS

rayon_min = 0		; rayon galactique minimum
rayon_max = 20		; rayon galactique maximum
;dr = 0.2		; espacement entre deux canaux en rayon
dr = 0.4		; espacement entre deux canaux en rayon

base_v = -100.		; valeur minimale en vitesse du cube
base_b = -20.		; valeur extreme en b
base_l = 90.		; valeur extreme en l du cube
dv = 1.0305165   	; espacement entre deux canaux en vitesse
deg_per_pix = 30.0/60.0
R0 = 10.
THETA0 = 220.


; INITIALISTION DU CUBE (l, b, R)
restore, '/net/srvr/pb1/mamd/datatoutevit.idl'
image1 = data_cube
;restore, '/net/srvr/pb1/mamd/hitoutevitf31_1.idl'
;image1 = hitoutevit
taille=size(image1)
hi_dis = fltarr(taille(1), taille(2), fix((rayon_max-rayon_min)/dr))
hi_dis(*,*,*)=0.0


; TRANSFERT DE L'INFO D'UN CUBE A L'AUTRE

for x=0, taille(1)-1 do begin
print, 100.*x/(taille(1)-1), ' %'
   for y=0, taille(2)-1 do begin
      for i=0, taille(3)-1 do begin
	l = base_l-x*deg_per_pix 
	l = l*!pi/180.
	b = base_b+y*deg_per_pix 
	b = b*!pi/180.
;	vmin = 3.16360*sin(l)*cos(b)
	vmin = 3.16360*sin(l)
	vitesse = (base_v+dv*i)/cos(b)
	if (vitesse gt vmin) then begin	; on traite les points a "v. pos"
;  	  vmax = THETA0*(1.01438-sin(l))*cos(b)
  	  vmax = THETA0*(1.01438-sin(l))
	  if (vitesse gt vmax) then vitesse = vmax   ;ramener au point tangent
	  rayon = 1.01438*R0*THETA0*sin(l)/(vitesse + THETA0*sin(l))
	endif
	if (vitesse le vmin) then rayon = R0
	  if (rayon gt rayon_min) then begin
	    NH1_i = image1(x,y,i)
	    position = fix((rayon-rayon_min)/dr)
	    if (position gt 49) then position = 49
	    hi_dis(x,y,position) = hi_dis(x,y,position) + NH1_i
	  endif
      endfor
    endfor
endfor


; SAUVEGARDE

nom='/home/mamd/idl/hi/hi_l_b_r.idl'
save, hi_dis, filename=nom

end
