PRO create_light_version,dir1,dir2

;Creates or updates a light version of a set of procedures contained into dir1
;into dir2
;Only procedures which have been compiled are updated

toberemoved=['Compiled Procedures:','$MAIN$','Compiled Functions:']

help,/source_files,output=helpout
Nhelp=(size(helpout))(1)

;=== clean the list of compiled routines and functions
routines=[''] & paths=routines & posdir=[0L]
FOR i=0,Nhelp-1 DO BEGIN
  str=strtrim(helpout(i),2)
  ind=where(toberemoved EQ str,count)
  IF count EQ 0 THEN BEGIN
    str=strcompress(helpout(i))
    pos=strpos(str,' ')
    routines=[routines,strmid(str,0,pos(0))]
    new_path=strmid(str,pos(0)+1,strlen(str)-pos(0))
    paths=[paths,new_path]
    posdir=[posdir,strpos(new_path,dir1)]
  ENDIF
ENDFOR
routines=routines(1:*)
paths=paths(1:*)
posdir=posdir(1:*)

Nhelp=(size(routines))(1)

;=== select compiled routines/functions belonging to dir1
ind=where(posdir NE -1,Nhelp)
routines=routines(ind)
paths=paths(ind)

stop

;=== Update new directory with the routines/functions
FOR i=0,Nhelp-1 DO BEGIN
  file1=paths(i)
  rout_name=strlowcase(routines(i))+'.pro'
  pos=strpos(paths(i),':')
  new_dir=dir2+
  file2=dir2+rout_name
  mac_cp,file1,file2
ENDFOR

stop

END