Function find_ind,etat,what,mask=mask,silent=silent,nmin = nmin,count=count

;+
; NAME:
;     find_ind
; PURPOSE:
;       finds start and end index of what in etat
; CATEGORY:
;       SPM
; CALLING SEQUENCE: 
;       deb_fin=find_ind(etat,what[,mask=mask])
; INPUTS:
;       etat = input vector (4 bands) (1 or 2 D array)
;	what = value to be identified (1 value or 2 elemt set)
; OPTIONAL INPUT PARAMETERS:
; OUTPUTS:
;	deb_fin = set indicating begin and end of each section found
;	what = is set to indef if what is not found
; OPTIONAL OUTPUT PARAMETERS:
;       mask = 1 at begining of connex regions and -1 just after
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;    
; MODIFICATION HISTORY:
;      03-Sep-94, Written by M. Giard and J.P. Bernard
;      17_Mar-00, Modified JPB to better use memory
;-

IF N_PARAMS(0) LT 2 THEN BEGIN
  PRINT,'Call: deb_fin=find_ind(etat,what[,mask=mask][,/silent])'
  GOTO, sortie
ENDIF

;find dim of what   
siwhat=size(what) & Ndim=siwhat(0)   
sietat=size(etat)   
   
IF siwhat(0) EQ 0 THEN BEGIN   
  Netat=sietat(1)    
  mask=bytarr(Netat)    
  indwhat=where(etat EQ what,count) 
  IF count EQ 0 THEN BEGIN
    IF not keyword_set(silent) THEN BEGIN
      message,'Value not found',/info
    ENDIF
    what=!indef
    GOTO,sortie
  ENDIF
ENDIF ELSE BEGIN   
  Netat=sietat(2)   
  mask=bytarr(Netat)    
  indwhat=where(etat(0,*) EQ what(0) AND etat(1,*) EQ what(1),count)
  IF count EQ 0 THEN BEGIN
    IF not keyword_set(silent) THEN BEGIN
      message,'What='+what(0)+what(1)+' values not found',/info
    ENDIF
    what(*)=!indef
    GOTO,sortie
  ENDIF  
ENDELSE

mask(indwhat)=1    
mask=[mask(0),mask,mask(netat-1)]
    
mask=mask-shift(mask,1)
mask=mask(1:netat+1)
   
IF siwhat(0) EQ 0 THEN BEGIN   
  IF etat(0) EQ what THEN BEGIN    
    mask(0)=1    
  ENDIF    
  IF etat(netat-1) EQ what THEN BEGIN    
    mask(netat)=-1     
  ENDIF
ENDIF ELSE BEGIN   
  IF (etat(0,0) EQ what(0) AND etat(1,0) EQ what(1)) THEN BEGIN    
    mask(0)=1    
  ENDIF    
  IF (etat(0,netat-1) EQ what(0) AND etat(1,netat-1) EQ what(1))  THEN BEGIN    
    mask(netat)=-1    
  ENDIF
ENDELSE   
;stop    
indp=where(mask EQ 1,countp)    
;indm=where(mask EQ -1.,countm)    
indm=where(mask EQ 255,countm)

IF countp NE countm THEN BEGIN  
  message,'find_ind:Stopped because countp NE countm'  
ENDIF  
Nomb=countp    
deb_fin=lonarr(Nomb,2)  
     
;stop    
FOR i=0,Nomb-1 DO BEGIN    
  deb_fin(i,0)=indp(i) 
  deb_fin(i,1)=indm(i)-1      
ENDFOR    

if keyword_set (nmin) and n_elements(deb_fin) ge 2 then begin
   s = size(deb_fin)

   ntot = n_elements(mask)

   ndf = s(1)

   dfp = fltarr(ndf,2)
   nok = 0
   for i=0,ndf-1 do begin
      if deb_fin(i,1) - deb_fin(i,0) +1 ge nmin then begin
         dfp(nok,*) = deb_fin(i,*)
         nok = nok+1
      endif else begin
         mask(deb_fin(i,0))=0
         if deb_fin(i,1)+1 le ntot-1 then mask(deb_fin(i,1)+1)=0
      endelse
   endfor

   if nok ne 0 then deb_fin=dfp(0:nok-1,*) else begin
      deb_fin = -1
      what(*) = !indef
      PRINT,'find_ind: What =',what,' value not found'
   endelse
endif

count=nomb

RETURN,deb_fin    
  
sortie:  
      
END    
