FUNCTION get_tag_type,struct,tag_names=tag_names,tag_size=tag_size

;+
; NAME:
;	get_tag_type
; PURPOSE:
;    returns the type of tags in an IDL structure
; CATEGORY:
;    JPBLib
; CALLING SEQUENCE: 
;	res=get_tag_type(struct,tag_names=tag_names,tag_size=tag_size)
; INPUTS:
;    struct  = input structure
; OPTIONAL INPUT PARAMETERS:
; OUTPUTS:
;	res        = type of tags
; OPTIONAL OUTPUT PARAMETERS:
;    tag_names  = tag names
;    tag_size   = tag size
; ACCEPTED KEY-WORDS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;
; Uses :
; MODIFICATION HISTORY:
;	Written Jan 31 1995 J.P. Bernard, IPAC.
;-

Ntags=N_tags(struct)
tag_type=strarr(Ntags)
tag_names=tag_names(struct)
tag_size=strarr(Ntags) & tag_size(*)=''
FOR i=0,Ntags-1 DO BEGIN
  si=size([struct.(i)])
  type=si(si(0)+1)
  CASE type OF
    1: tag_type(i)='B'   ;Byte
    2: tag_type(i)='I'   ;integer
    3: tag_type(i)='J'   ;long integer
    4: tag_type(i)='F'   ;float
    5: tag_type(i)='D'   ;double
    7: tag_type(i)='A'   ;string
    ELSE: message,'Unrecognized tag type'+type
  ENDCASE
  si=size(struct.(i))
  IF si(0) NE 0 THEN BEGIN
    tag_size(i)='('
    FOR j=0,si(0)-1 DO BEGIN
      tag_size(i)=tag_size(i)+strtrim(si(j+1),2)
      IF j NE si(0)-1 THEN tag_size(i)=tag_size(i)+','
    ENDFOR
    tag_size(i)=tag_size(i)+')'
  ENDIF
ENDFOR

RETURN,tag_type

END