;+
; NAME:
;       select_from_list
; CALLING SEQUENCE:
;       res=select_from_list(list,already_selected=already_selected)
; PURPOSE:
;       returns the user selection from a list of strings (widget)
; INPUTS:
;       list    = input list to choose from
; OPTIONAL INPUT:
;	   already_selected = list of already selected strings
; OUTPUTS:
;	   res       = list of selected strings
; PROCEDURE AND SUBROUTINE USED
; SIDE EFFECTS:
; EXAMPLE:
; MODIFICATION HISTORY:
;       written by Jean-Philippe Bernard 17/01/00
;-

PRO select_from_list_event,ev

common select_from_list_outvar,outvar

;=========== Get first child number
child1=widget_info(ev.handler,/child)

;=========== Get the state structure
widget_control,child1,get_uvalue=state,/no_copy

;stop
widget_control,ev.id,get_uvalue = eventval

CASE eventval OF
  'Done': BEGIN
    widget_control,state.widgets.pick,get_value=selected_list
    state.values.selected_list=ptr_new(selected_list)
    outvar=selected_list
    widget_control,child1,set_uvalue=state,/no_copy
    widget_control,ev.top,/destroy
    RETURN
  END
ENDCASE

widget_control,child1,set_uvalue=state,/no_copy

END

FUNCTION select_from_list,list,already_selected=already_selected

common select_from_list_outvar,outvar

version='1.0'

w_state={base:0L,done:0L,pick:0L}
v_state={selected_list:ptr_new(),already_selected:ptr_new()}

base = widget_base(title = 'List Selection ' +version,/column)
child1 = widget_label(base,value='')
w_state.base = base
IF keyword_set(already_selected) THEN v_state.already_selected=ptr_new(already_selected)

w_state.pick = cw_pickvalues(base,value=list,already_selected=already_selected)

w_state.done=WIDGET_BUTTON(base,VALUE='Done',uvalue='Done')

widget_control,w_state.base,/realize

state={widgets:w_state,values:v_state}

out_var=state.values.selected_list

widget_control,child1,set_uvalue=state

xmanager,'Archeops Display',w_state.base, $
         event_handler='select_from_list_event'

;stop

RETURN,outvar

END