function str_dms,val,hours=hours,dms=dms 

;+
; NAME:
;       str_dms
; CALLING SEQUENCE:
;       res=str_dms(val[,/hours][,/dms])
; PURPOSE:
;       output val in hh:mm:ss or dd:'':"" format
; INPUTS:
;       val = value to be converted
; OPTIONAL INPUT:
;	   /hours    : hh:mm:ss format
;	   /dms       : dd:'':"" format
; OUTPUTS:
;	   converted string
; PROCEDURE AND SUBROUTINE USED
;       
; SIDE EFFECTS:
; EXAMPLE:
; MODIFICATION HISTORY:
;       written by Jean-Philippe Bernard (?) 09-92
;-

;on_error,2

IF n_params(0) NE 1 THEN BEGIN
  print,'Calling sequence: res=str_dms(val[,/hours][,dms=dms]) '
  goto,sortie
ENDIF

dd = abs(sixty(val)) 
         
if val lt 0 then sg='-' else sg='+' 
 
         
         
un = ['d',"'",'"']       
if keyword_set(hours) then un=['h','m','s'] 
if keyword_set(dms) then un=['d','m','s'] 
 
fmt='(a,I2,a,I2,a,I2,a)' 
if keyword_set(hms) then fmt='(a,I2,a,I2,a,f4.1,a)' 
resu = strtrim(string(sg,dd(0),un(0),dd(1),un(1),dd(2),un(2), $ 
                format=fmt),2) 
         
return,resu
sortie:
end 
