FUNCTION str_hms,val,degrees=degrees

;+
; NAME:
;       str_hms
; CALLING SEQUENCE:
;       res=str_hms(val[,/degrees])
; PURPOSE:
;       output val in hh:mm:ss or dd:'':"" format
; INPUTS:
;       val = value to be converted
; OPTIONAL INPUT:
;	   /degrees       : for dd:'':"" format
; OUTPUTS:
;	   converted string
; PROCEDURE AND SUBROUTINE USED
;       
; SIDE EFFECTS:
; EXAMPLE:
; MODIFICATION HISTORY:
;       written by Jean-Philippe Bernard (?) 09-92
;-

IF n_params(0) NE 1 THEN BEGIN
  print,'Calling sequence: res=str_hms(val[,/degrees]) '
  goto,sortie
ENDIF

dd = sixty(val)
un=['h','m','s']
if keyword_set(degrees) then un = ['d',"'",'"']
fmt='(I2,a,I2,a,f4.1,a)'
resu = string(dd(0),un(0),dd(1),un(1),dd(2),un(2), $
	        format=fmt)
return,resu
sortie:
END
