FUNCTION structure_selection,st,count=count,_extra=extra
;+
; NAME:
;     structure_selection
; PURPOSE:
;     select particular values within a structure array
; CATEGORY:
;     General
; CALLING SEQUENCE: 
;     res=structure_selection(struct,keyword1=[,keyword2=][...])
; INPUTS:
;     struct = any array of structures (not the other way around !)
; OPTIONAL INPUT PARAMETERS:
;     None
; KEYWORDS:
;     any tag name of struct
; OUTPUTS:
;	res = the structure containing selected entries of struct
; OPTIONAL OUTPUT PARAMETERS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
;     When several Kwords are provided, AND between the conditions is assumed
;     When the kwords are arrays, all must have the same size, and only struct
;          entries matching the sets are returned
; EXAMPLE:
;     one_st={a:'',b:0.,c:5.} & st=replicate(one_st,10)
;     st(0:2).a='aaaa' & st(3:6).a='bbbb'
;     st(1:4).b=2.     & st(5:7).b=3.
;     sst=structure_selection(st,a=['aaaa']) & help,sst
;          SST             STRUCT    = -> <Anonymous> Array[3]
;     sst=structure_selection(st,a=['aaaa'],b=[2.]) & help,sst
;          SST             STRUCT    = -> <Anonymous> Array[2]
;     sst=structure_selection(st,a=['aaaa','bbbb'],b=[2.,3]) & help,sst
;          SST             STRUCT    = -> <Anonymous> Array[4]
; PROCEDURE:
;     Nice programing ugh ?!
; MODIFICATION HISTORY:
;     02-Fev-00, Written by J.P. Bernard
;-

IF N_PARAMS(0) LT 1 THEN BEGIN
  PRINT,'Call: sst=structure_selection(st,tag1=[,tag2=][, ...])'
  GOTO, sortie
ENDIF

possible_kwords=tag_names(st)
Kwords=tag_names(extra)

match,possible_kwords,Kwords,ind1,ind2,count=Nkey

IF Nkey EQ 0 THEN BEGIN
  message,'None of the provided Kwords was found in the structure',/info
  goto,sortie
ENDIF

count=0L
Nvalues=(size([extra.(0)]))(1)
out_st = [st(0)]
values = ptrarr(Nkey)
FOR i=0,Nkey-1 DO values(i)=ptr_new([extra.(ind2(i))])

FOR v=0,Nvalues-1 DO BEGIN
  sst=st
  str = 'ind=where('
  FOR i=0,Nkey-1 DO str = str + 'sst.('+strtrim(ind1(i),2)+') EQ '+strtrim((*(values(i)))(v),2)+' AND '
  strput,str,',cnt)',strlen(str)-5
  toto = execute(str)
  IF cnt NE 0 THEN BEGIN
    out_st=[out_st,sst(ind)]
    count=count+n_elements(ind)
  ENDIF ELSE BEGIN
    message,'Found no entry with '+str,/info
  ENDELSE
ENDFOR
IF count GT 0 THEN out_st = out_st(1:*) ELSE out_st = -1

RETURN,out_st

sortie:

END
