FUNCTION which_pro,routine_name

;+
; NAME:
;   which_pro
; PURPOSE:
;       prints which routine(s) is compiled in the !path
; CATEGORY:
;       JPBlib
; CALLING SEQUENCE: 
;       str=which_pro(routine_name)
; INPUTS:
;       routine_name = name of an IDL routine
; OPTIONAL INPUT PARAMETERS:
; OUTPUTS:
;	   str = string giving the full path toward the routine(s)
; OPTIONAL OUTPUT PARAMETERS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
;    
; MODIFICATION HISTORY:
;      Written by J.P. Bernard, 17/00/00
;-

IF N_PARAMS(0) EQ 0 THEN BEGIN
  PRINT,'Calling Sequence: '
  PRINT,'res=which_pro(routine_name)'
  GOTO, closing
ENDIF

CASE !version.os OF
  'MacOS':BEGIN
    sep=':'
    path_sep=','
    add_sep=''
  END
  'Win32':BEGIN
    sep='\'
    path_sep=';'
    add_sep=sep
  END
  'linux':BEGIN
    sep='/'
    path_sep=':'
    add_sep=sep
  END
  'hp-ux':BEGIN
    sep='/'
    path_sep=':'
    add_sep=sep
  END
  ELSE: BEGIN
    sep='/'
    path_sep=':'
    add_sep=sep
  END
ENDCASE

rout=routine_name
pos=strposmulti(routine_name,'.pro',count)
IF count EQ 0 THEN rout=rout+'.pro'

str=str_sep(!path,path_sep)
Nstr=(size(str))(1)

files=['']
ccount=0L
FOR i=0L,Nstr-1 DO BEGIN
;  print,i,Nstr,str(i)+add_sep+rout
  file=findfile(str(i)+add_sep+rout,count=count)
  IF count NE 0 THEN BEGIN
    files=[files,file(0)]
    ccount=ccount+1
;    stop
;    print,file
  ENDIF
ENDFOR
;stop

IF ccount NE 0 THEN files=files(1:*)

RETURN,files

closing:

END
