FUNCTION data2healp,signal,lon,lat,nside,ordering=ordering

Npix = 12L*long(nside)^2
healp_out=fltarr(Npix)

message,'Computing Healpix pixels ...',/info
lati=lat/!radeg
longi=lon/!radeg
ang2pix, nside,!pi/2.-lati,longi,pixnum,ordering=ordering

message,'Ordering the input signal ...',/info
order=sort(pixnum)
d=signal(order)
pixnum=pixnum(order)
message,'Selecting defined values in input signal ...',/info
ind=where(d NE !indef,count1)
d=d(ind)
pixnum=pixnum(ind)
pixmax=pixnum(count1-1)

message,'Computing healpix vector ...',/info
i_start=0L
i=i_start

REPEAT BEGIN
  pixcur=pixnum(i)
  WHILE (pixnum(i) EQ pixcur) DO BEGIN
    i=i+1
  ENDWHILE
;  stop
  i_end=i-1
  zone=d(i_start:i_end)
  healp_out(pixcur)=avg(zone)
  i_start=i
;  print,pixcur,i_start,i_end
ENDREP UNTIL pixcur EQ pixmax-1
message,'Done.',/info

RETURN,healp_out
END
