PRO auto_help,routine_name,is_function=is_function

;+
; NAME:
;	auto_help
; PURPOSE:
;    Prints an automatic on line help for a routine or function
; CATEGORY:
;    JPBLib
; CALLING SEQUENCE: 
;	res=auto_help(routine_name[,/is_function])
; INPUTS:
;    routine_name = name of an IDL routine
; OPTIONAL INPUT PARAMETERS:
; OUTPUTS:
;	res = string array giving the in line help
; OPTIONAL OUTPUT PARAMETERS:
; ACCEPTED KEY-WORDS:
;    is_functions = must be set if the routine is a function
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
; MODIFICATION HISTORY:
;	Written J.P. Bernard, 18/01/00
;-

IF N_PARAMS(0) LT 3 THEN BEGIN
  PRINT,'Calling Sequence: '
  PRINT,'res=auto_help(routine_name[,/is_function])'
  GOTO, closing
ENDIF

Nchar_max=80

;routine_name='image_cont20'
res=routine_info(routine_name,/parameters,func=is_function)
IF not keyword_set(is_function) THEN BEGIN
  str1='Usage : '+routine_name+','
ENDIF ELSE BEGIN
  str1='Usage : '+'result='+routine_name+'('
ENDELSE
FOR i=0,res.num_args-1 DO BEGIN
  str1=str1+res.args(i)
  IF i NE res.num_args-1 THEN str1=str1+','
ENDFOR
IF keyword_set(is_function) THEN str1=str1+')'
sstr1=['']
IF strlen(str1) GT Nchar_max THEN BEGIN
  WHILE strlen(str1) GT Nchar_max DO BEGIN
    pos=strposmulti(str1,',')
    ind=where(pos LE Nchar_max,count)
    sstr1=[sstr1,strmid(str1,0,pos(count-1))]
    str1=strmid(str1,pos(count-1),strlen(str1)-pos(count-1))
  ENDWHILE
  sstr1=[sstr1,str1]
  sstr1=sstr1(1:*)
ENDIF ELSE BEGIN
  sstr1=[str1]
ENDELSE

str2='Kwords: '
FOR i=0,res.num_kw_args-1 DO BEGIN
  str2=str2+res.kw_args(i)
  IF i NE res.num_kw_args-1 THEN str2=str2+','
ENDFOR
sstr2=['']
IF strlen(str2) GT Nchar_max THEN BEGIN
  WHILE strlen(str2) GT Nchar_max DO BEGIN
    pos=strposmulti(str2,',')
    ind=where(pos LE Nchar_max,count)
    sstr2=[sstr2,strmid(str2,0,pos(count-1))]
    str2=strmid(str2,pos(count-1),strlen(str2)-pos(count-1))
  ENDWHILE
  sstr2=[sstr2,str2]
  sstr2=sstr2(1:*)
ENDIF ELSE BEGIN
  sstr2=[str2]
ENDELSE

FOR i=0,n_elements(sstr1)-1 DO BEGIN
  print,sstr1(i)
ENDFOR
FOR i=0,n_elements(sstr2)-1 DO BEGIN
  print,sstr2(i)
ENDFOR

closing:

END
