FUNCTION create_overlay_st,N_values

;+
; NAME:
;          create_overlay_st
; PURPOSE:
;          Create an empty overlay structure for image_cont20
; CATEGORY:
;          Image Display
; CALLING SEQUENCE:
;          st=create_overlay_st(N_values)
; INPUTS:
;          N_values : Array containing the number of overlays in in set
; OPTIONAL INPUTS:
;          None
; KEYWORD PARAMETERS:
;          None
; OUTPUTS:
;          st       : overlay structure
; OPTIONAL OUTPUTS:
;          None
; COMMON BLOCKS:
;          None
; SIDE EFFECTS:
;          None
; RESTRICTIONS:
;          None
; PROCEDURE:
;          Uses create_struct 
; EXAMPLE:
;          overlay=create_overlay_st([3,7])
;          help,overlay,/str
;          help,overlay.set0,/str
; MODIFICATION HISTORY:
;          Created by J.-Ph. Bernard @ IAS on Wed Jul 30 1997
;          Modified JPB Aug. 31 1998, to be compatible with jpb_plotsym.
;-

IF n_params(0) EQ 0 THEN BEGIN
  print,'Calling Sequence: st=create_overlay_st(N_values)'
  print,'KWords          : None'
  GOTO,sortie
ENDIF

si=size(N_values) & N_set=si(1)

Nchar=8
;seed=0
sttr='st={'
tagnames=['coo1','coo2', $
          'sym_type','sym_size','sym_color','sym_thick', $
          'sym_angle','sym_fill','sym_double', $
          'label','label_size','label_color','label_thick','label_angle']
FOR i=0,N_set-1 DO BEGIN
  nstr=strtrim(string(n_values(i)),2)
  istr=strtrim(string(i),2)
  tag_typ='F('+nstr+'),F('+nstr+'),A('+nstr+'),F('+nstr+'),I('+ $
          nstr+'),I('+nstr+'),F('+nstr+'),I('+nstr+'),I('+nstr+'),A('+ $
          nstr+'),I('+nstr+'),I('+nstr+'),I('+nstr+'),F('+nstr+')'
;  print,tag_typ
;  name='st'      
;  FOR j=0,Nchar DO BEGIN
;    name=name+strtrim(string(fix(randomu(seed)*10)),2)
;  ENDFOR
;  name='st'+istr
  name=''
  str='my_create_struct,st'+istr+',name,tagnames,tag_typ'
;  stop
  truc=execute(str)
  sttr=sttr+'set'+istr+':st'+istr
  IF i NE N_set-1 THEN sttr=sttr+','
ENDFOR
sttr=sttr+'}'

truc=execute(sttr)

;clean up the mess
;IF !version.os EQ 'MacOS' THEN remove_tmp_files

RETURN,st
sortie:
END
