; $Id: my_xrdpix.pro,v 1.1 2004/01/06 15:41:25 bernard Exp $

Pro my_xRdpix, Image,X0, Y0,ix,iy,fx,fy,value,header=header,equinox=equinox, $
               coo1=coo1,coo2=coo2,degrees=degree,ev=ev,window_out=window_out, $
               clic_coo=clic_coo,use_coo=use_coo

;Read the value of the pixel under the cursor
;Display x,y and the pixel value under the cursor
;+
; NAME:
;	my_xRDPIX
;
; PURPOSE:
;	Interactively display the X position, Y position, and pixel value 
;	of the cursor.
;
; CATEGORY:
;	Image display.
;
; CALLING SEQUENCE:
;	RDPIX, Image [, X0, Y0]
;
; INPUTS:
;	Image:	The array that represents the image being displayed.  This 
;		array may be of any type.  Rather reading pixel values from 
;		the display, they are taken from this parameter, avoiding 
;		scaling difficulties.
;
; OPTIONAL INPUT PARAMETERS:
;	X0, Y0:	The location of the lower-left corner of the image area on
;		screen.  If these parameters are not supplied, they are
;		assumed to be zero.
;
; OUTPUTS:
;	None.
;
; COMMON BLOCKS:
;	None.
;
; SIDE EFFECTS:
;	The X, Y, and value of the pixel under the cursor are continuously 
;	displayed.
;
; RESTRICTIONS:
;	None.
;
; PROCEDURE:
;	Instructions are printed and the pixel values are printed as the 
;	cursor is moved over the image.
;
;	Press the left or center mouse button to create a new line of output,
;	saving the previous line.
;
;	Press the right mouse button to exit the procedure.
;
; MODIFICATION HISTORY:
;	DMS, Dec, 1987.
;	Rob Montgomery (rob@hao.ucar.edu), 9/21/92;
;		Correct indices for case of !order = 1
;
;-

;@comxrdpix.com		;contains text_pixel_value,text_unit_pixel

on_error,2                      ;Return to caller if an error occurs
;stop
si=size(image) & xmax=si(1) & ymax=si(2)
bunit=sxpar(header,'BUNIT',count=count)
IF count EQ 0 THEN bunit=' '
ctype=sxpar(header,'CTYPE1')
equ_header=sxpar(header,'EQUINOX',count=count)
;;IF count EQ 0 THEN equ_header='????'
IF count EQ 0 THEN equ_header='1950'
cor_proj_dec,ctype,coord,proj,projtype,status,/silent

;print,'toto'

s = size(image)
if s(0) ne 2 then message, 'Image parameter not 2d.'
s(1) = s(1)-1                   ;To n-1
s(2) = s(2)-1
!err=0
if n_elements(x0) le 0 then x0 = 0
if n_elements(y0) le 0 then y0 = 0
if s(s(0)+1) ge 4 then form = 'F' else form = 'I'
cr = string("15b)	;this codes a newline
;form="($,'x=',i4,', y=',i4,', value=',"+form+",a)"
equistr=strmid(strtrim(string(equ_header),2),0,4)

IF keyword_set(equinox) THEN equistr=strmid(strtrim(string(equinox),2),0,4)

CASE coord OF
    'RA': BEGIN
        c1ch='alpha('+equistr+')=' & c2ch='delta('+equistr+')='
        c1ch="' "+c1ch+"'" & c2ch="' "+c2ch+"'"
        form="($,i4,' ',i4,"+c1ch+",a,"+c2ch+",a,' value=',"+form+",' "+bunit+"',a)"
    END
    'GLON': BEGIN
        form="($,i4,' ',i4,' l=',a,', b=',a,', value=',"+form+",' " +bunit+"',a)"
    END
ENDCASE

IF not keyword_set(ev) THEN BEGIN
    tvrdc,x,y,2,/dev
ENDIF ELSE BEGIN
    x=ev.x & y=ev.y
ENDELSE

x = x-x0 & y = y - y0
if (x le s(1)) and (y le s(2)) and (x ge 0) and (y ge 0) then begin
    if (!order eq 1) then yy = s(2) - y else yy = y
    err_v=!err
;	   print,'!err=',!err
;print,'x,y      =',x,y
;print,x*fx-0.5,y*fy-0.5
;stop
    IF keyword_set(use_coo) THEn BEGIN
        co1=coo1(x*fx-0.5,y*fy-0.5)
        co2=coo2(x*fx-0.5,y*fy-0.5)
    ENDIF ELSE BEGIN
        h2pix,header,/silent
;             pix2coo2,fix(x*fx),fix(y*fy),co1,co2,/silent
        pix2coo2,x*fx-0.5,y*fy-0.5,co1,co2,/silent
    ENDELSE
    c1=co1 & c2=co2
;    stop
    IF keyword_set(equinox) THEN BEGIN
        precess,co1,co2,equ_header,equinox
    ENDIF
    !err=err_v
    IF x LT xmax AND y LT ymax THEN BEGIN
        rastr=str_hms(co1/15.) & decstr=str_dms(co2)
        IF keyword_set(degree) THEN BEGIN
            rastr=strtrim(string(co1),2)+' deg'
            decstr=strtrim(string(co2),2)+' deg'
        ENDIF
; Compute l,b
        precess,c1,c2,equ_header,1950.
        euler,c1,c2,l,b,1
        lstr=strtrim(string(l,format='(F6.2)'),2)
        bstr=strtrim(string(b,format='(F6.2)'),2)
        text_for_look = rastr + ' ' + decstr + ' ' +  $
          lstr+' '+bstr+' '+ $
          strtrim(string(Image(x,yy),format='(E10.3)'),2)+ $
          ' '+bunit
;             widget_control,text_pixel_value,set_value = text_for_look
        widget_control,window_out,set_value = text_for_look                            
        ix=x & iy=y & value=Image(x,yy)
    ENDIF
    IF keyword_set(clic_coo) THEN BEGIN
        IF ev.press EQ 1 THEN clic_coo=[co1,co2]
    ENDIF
ENDIF
END
