FUNCTION cloud_mass,nh2,area,dis
;
; To derive total molecular mass from 
; H2 column density
;
;
;

mass=-1
;check inputs........................................
npar=N_PARAMS()
IF(npar LT 3) THEN BEGIN
print,'PURPOSE: To derive total molecular mass.'
print,'CALLING SEQUENCE:'
print,'	Calling sequence: mass=cloud_mass(nh2,area,dis)'
print,'INPUTS:'
print,'	nh2 = the column density of H2 in cm^-2'
print,'	area = surface are in arcsec^2'
print,'	dis = cloud distance in pc'
print,'OUTPUTS:'
print,'	mass = cloud mass in solar mass'
goto,ending
ENDIF
;undifined values------------------------------------
ind_good=where(nh2 NE !indef,cnt_good)
IF(cnt_good EQ 0) THEN GOTO, ending
mass=nh2 & mass(*)=!indef
;General Constants.............................
pc=3.08*10^18.			;1 pc [cm]
au=1.50*10^13.			;1 AU [cm]
Mo=1.989*10^33.			;1 solar mass [g]
Mp=1.6735*10^(-24.)		;proton mass [g]
MH2=Mp*2.4			;mean molecular 
				; weight corrected for He[g]
; calculation.....................................
mass(ind_good)=(nh2(ind_good)*MH2*area*(dis*au)^2.)/Mo
;ending........................................
ending:
RETURN,mass
END
