FUNCTION planck_kd,rfreq,temp
;
;Plank function
;
J=-1
npar=N_PARAMS()
IF(npar LT 2) THEN BEGIN
print,'CALLING SEQUENCE:'
print,'	Calling sequence: J=plank(rest_frequency,temperature)'
print,'INPUTS:'
print,'	rest_frequency = Scalor or 1D string array in Hz'
print,'	temperature = Temperature in K'
goto,ending
ENDIF

h=6.6261*10.^(-27.)	;plank constant [erg s]
k=1.3807*10.^(-16.)	;boltzman constant [erg/K]

ind_good=where(temp NE !indef,cnt_good)
IF(cnt_good EQ 0) THEN goto,ending
J=temp & J(*)=!indef

a2=(h*rfreq)/k
J(ind_good)=a2/(exp(a2/temp(ind_good))-1.)	;planck func
ending:
return,J
end
