FUNCTION BBNU,nu,T

hk=6.63E-27/1.38e-16
toto=hk*nu/T
ind=where(toto LT 30,count)
BB=toto & BB(*)=0.

IF count NE 0 THEN BB(ind)=(nu(ind)/1.e12)^3/(exp(toto(ind))-1.)*1.e36

RETURN,BB
END

FUNCTION color_correct,nu0,nufilt,Tfilt,n,T,input_spec=input_spec

;Compute color correction cc
;cc is defined such that I0=cc*I(nu0) where I0 is the nuInu=cste convention value
;and I(nu0) is the spectrum taken at the reference frequency of the filter nu0
;cc is compuetd for a given filter transmission and
;a spectrum (either Inu \propto (nu/nu0)^n*Bnu(T) or provided in input_spec
;nu, nufilt and nu0 must be in Hz
;nufilt and Tfilt are 1D array of the same dimension
;if input_spec is provided, it is used instead of I1*(nu/nu0)^n*Bnu(T)
;example:
;st=dm_read_filters(/plot_it)
;cc=color_correct(st.dirbe.central_frequencies(7),*(st.dirbe.filter_frequencies(7)), $
;                 *(st.dirbe.filter_transmissions(7)),0.5,10.)
;IDL> print,cc
;      1.29394

arr1=Tfilt*(nufilt/nu0)^(-1)
IF not keyword_set(input_spec) THEN BEGIN
  arr2=Tfilt*(nufilt/nu0)^(n)*BBnu(nufilt,T)/BBnu(nu0,T)
ENDIF ELSE BEGIN
  arr2=Tfilt*input_spec/(interpol(input_spec,nufilt,nu0))(0)
ENDELSE

cc=integral(nufilt,arr1,min(nufilt),max(nufilt))/ $
      integral(nufilt,arr2,min(nufilt),max(nufilt))
;I1=I0*int_tabulated(nufilt,arr1)/int_tabulated(nufilt,arr2)

RETURN,cc

END
