pro fit_spectra,bidon,data=data,header=header

;+
; NAME:
;       fit_spectra
; PURPOSE:
;       fit molecular data with gaussians interactively
; CATEGORY:
;       
; CALLING SEQUENCE:
;	fit_spectra
; INPUTS:
;       
; OPTIONAL INPUT PARAMETERS:
;       data = data cube
;       header = corresponding header
; OUTPUTS:
;       None
; OPTIONAL OUTPUT PARAMETERS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
; PROCEDURE:
; PRO and FUNCTION USED:
;	imcont21
; MODIFICATION HISTORY:
;      1-Jun-1998, Written by Jean-Philippe Bernard (v 1.0)
;                   Using Dobashi's program 
;-

loadct,13

version='1.0'
w_state={base:0l,fbl:0l,file:0l,quit:0l,ncompo:0l,draw:0l, $
         islider:0l,jslider:0l, $
         fit:0l,accept:0l,see:0l,print:0l,info:0l,filename:0l,tex_mess:0l, $
         tmin:0l,tmax:0l,vmin:0l,vmax:0l,compo_number:0l,autosave:0l,rebin:0l, $
         next:0l,fixtr:0l,fixv:0l,fixdv:0l,vpos:0l,tpos:0l,Tfixed:0l, $
         vfixed:0l,dvfixed:0l, $
         plot_it:0l,bestfit:0l,compo_best:0l,buttons:0l,baseline:0l, $
         base_degree:0l,ifirst:0l,jfirst:0l,increase:0l,decrease:0l, $
         fromref:0l,autofit:0l,stopautofit:0l}

v_state={outfile:'', $
         ivalue:0l,jvalue:0l,previous_path:'',previous_save_path:'', $
         save_filter:'',filter:'',window:-1l, $
         ncompo:0l,ncompo_max:1l,Nx:0l,Ny:0l,Nz:0l,last_ifit:0l,last_jfit:0l, $
         vrange:[0,0.],trange:[0,0.],compo_number:0l,frmt1:'', $
         vmin_fixed:0l,vmax_fixed:0l, $
         Tmin_fixed:0l,Tmax_fixed:0l,autosave:0l,rebin:1,frmt2:'', $
         last_press:0,last_clicks:0,last_release:0,frmt3:'', $
         plot_it:1,compo_best:1, $
         base_degree:2,baseline:0,ifirst:0,fromref:0,mode:'Interactive',delay:1}

ncompo=1
v_state.ncompo=ncompo
v_state.ncompo_max=ncompo
v_state.frmt1='(E10.2)'
v_state.frmt2='(I2)'
v_state.frmt3='(F7.3)'

frmt1=v_state.frmt1
frmt2=v_state.frmt2
frmt3=v_state.frmt3

ipos=0 & jpos=0
IF keyword_set(data) THEN BEGIN
  cube=data
  head=header
  si=size(cube)
  Nx=si(1) & Ny=si(2) & Nz=si(3)
  spec=reform(cube(ipos,jpos,*))
  vel=(indgen((size(spec))(1))-sxpar(head,'CRPIX3'))* $
       sxpar(head,'cdelt3')+xpar(head,'crval3')
  create_coo2,h,coo1,coo2,/silent
ENDIF ELSE BEGIN
  Nx=10 & Ny=10 & Nz=10
  cube=fltarr(Nx,Ny,Nz)
  head=strarr(10)
  spec=reform(cube(ipos,jpos,*))
  vel=1.*(indgen((size(spec))(1)))
  coo1=fltarr(Nx,Ny)+!indef & coo2=coo1
ENDELSE
coo1_ref=coo1 & coo2_ref=coo2

v_state.Nx=Nx & v_state.Ny=Ny & v_state.Nz=Nz

all_T=fltarr(Nx,Ny,v_state.ncompo+1)+!indef
all_v=all_t & all_dv=all_t
coef=fltarr(3*v_state.ncompo)+!indef
to_be_fitted=intarr(3*v_state.ncompo) & to_be_fitted(*)=1
fix_values=fltarr(3*v_state.ncompo) & fix_values(*)=1.
already_fitted=intarr(Nx,Ny)
all_T_fitted=intarr(Nx,Ny,v_state.ncompo+1)+!indef
all_v_fitted=all_T_fitted & all_dv_fitted=all_T_fitted
baseline=fltarr(1,2) & baseline(*,*)=!indef
head_R=head
all_T_R=all_T & all_V_R=all_V & all_dv_R=all_dV
all_T_fitted_R=all_T_fitted & all_V_fitted_R=all_V_fitted
all_dV_fitted_R=all_dV_fitted
im_state={cube:cube,header:head,spectrum:spec,velocity:vel,coef:coef, $
          all_T:all_T,all_v:all_v,all_dv:all_dv, $
          all_T_fitted:all_T_fitted,all_v_fitted:all_v_fitted, $
          all_dv_fitted:all_dv_fitted, $
          already_fitted:already_fitted,to_be_fitted:to_be_fitted, $
          coo1:coo1,coo2:coo2, $
          fix_values:fix_values,baseline:baseline,header_R:head_R, $
          all_T_R:all_T_R,all_v_R:all_v_R,all_dv_R:all_dv_R, $
          all_T_fitted_R:all_T_fitted_R,all_v_fitted_R:all_v_fitted_R, $
          all_dv_fitted_R:all_dv_fitted_R, $
          coo1_ref:coo1_ref,coo2_ref:coo2_ref}

;==================== Definition  of the base widget     
IF !version.os EQ 'sunos' THEN BEGIN
  bar=0 
ENDIF ELSE BEGIN
  bar=1
ENDELSE

IF bar NE 0 THEN BEGIN                     
  base = widget_base(title = 'fit_spectra '+version,/column,mbar=bar) 
ENDIF ELSE BEGIN
  base = widget_base(title = 'fit_spectra ' +version,/column)
ENDELSE
w_state.base=base
IF bar NE 0 THEN child1=bar ELSE child1 = widget_label(base,value='')
;==================== First button line
IF bar EQ 0 THEN BEGIN
  fbl = widget_base(base,/row)
ENDIF ELSE BEGIN
  fbl=bar
ENDELSE
print,'Bar widget =',bar
print,'Base Widget =',base
print,'fbl Widget =',fbl
w_state.fbl=fbl

junk = {cw_pdmenu_s,flags:0, name :''}
desc = [{cw_pdmenu_s,1,'File'}, $
        {cw_pdmenu_s,0,'Open Data File (Fits) ...'}, $
        {cw_pdmenu_s,0,'Save Fit Params ...'}, $
        {cw_pdmenu_s,0,'Restore Fit Params ...'}, $
        {cw_pdmenu_s,0,'Restore Reference Fit Params ...'}, $
        {cw_pdmenu_s,0,'Print'}, $
        {cw_pdmenu_s,0,'Quit'}]
toto = cw_pdmenu(fbl,desc,/return_name,uvalue='FILE',mbar=bar)

;w_state.info=WIDGET_BUTTON(fbl,VALUE='Info',uvalue='INFO')
desc = [{cw_pdmenu_s,1,'See'}, $
        {cw_pdmenu_s,0,'Header Info'}, $
        {cw_pdmenu_s,1,'Tr maps'}, $
        {cw_pdmenu_s,0,'T1'}, $
        {cw_pdmenu_s,0,'T2'}, $
        {cw_pdmenu_s,0,'T3'}, $
        {cw_pdmenu_s,0,'T4'}, $
        {cw_pdmenu_s,2,'T5'}, $
        {cw_pdmenu_s,1,'V maps'}, $
        {cw_pdmenu_s,0,'V1'}, $
        {cw_pdmenu_s,0,'V2'}, $
        {cw_pdmenu_s,0,'V3'}, $
        {cw_pdmenu_s,0,'V4'}, $
        {cw_pdmenu_s,2,'V5'}, $
        {cw_pdmenu_s,1,'dV maps'}, $
        {cw_pdmenu_s,0,'D1'}, $
        {cw_pdmenu_s,0,'D2'}, $
        {cw_pdmenu_s,0,'D3'}, $
        {cw_pdmenu_s,0,'D4'}, $
        {cw_pdmenu_s,2,'D5'}, $
        {cw_pdmenu_s,1,'Tr*dV maps'}, $
        {cw_pdmenu_s,0,'TdV1'}, $
        {cw_pdmenu_s,0,'TdV2'}, $
        {cw_pdmenu_s,0,'TdV3'}, $
        {cw_pdmenu_s,0,'TdV4'}, $
        {cw_pdmenu_s,2,'TdV5'}]
toto = cw_pdmenu(fbl,desc,/return_name,uvalue='SEE',mbar=bar)

;====================== Display window
ppal = widget_base(base,/row)
dimx = 600 & dimy= 300
w_state.draw = widget_draw(ppal,colors = 256,$                               
                   /motion_events,uvalue = 'DRAW' ,$
                   /frame,xsize=dimx*1, $
                   ysize=dimy*1,/button_events)
                   
;====================== Best fit parameters
bfit=widget_base(ppal ,/column,/frame)
toto = widget_label(bfit,value = 'Best Fit')

;=== try
Nmax=9
CASE !version.os OF
  'MacOS':BEGIN
    Nseey=4*50
    Nseex=3*90
  END
  'sunos':BEGIN
    Nseey=6*28
    Nseex=4*72		;4 rows
  END
ENDCASE

vv=strarr(3,Nmax) & vv(*,*)='---'
row_lab=strtrim(indgen(Nmax)+1,2)
w_state.bestfit=widget_table(bfit,column_lab=['T','V','dV'],  $
                          row_lab=row_lab,editable=1,all_events=1, $
                          alignment=2,value=vv, $
                          scr_ysize=Nseey,scr_xsize=Nseex,/scroll, $
                          uvalue='FITTED_TABLE')

;====================== Adopt Best Fit Button
hh=widget_base(bfit,/row)
junk = {cw_pdmenu_s,flags:0, name :''}
desc = [{cw_pdmenu_s,1,'Adopt'}, $
        {cw_pdmenu_s,0,'This Components'}, $
        {cw_pdmenu_s,0,'All Components'}]
toto = cw_pdmenu(hh,desc,/return_name,uvalue='ADOPT')

toto=WIDGET_BUTTON(hh,VALUE='Reset',uvalue='RESET')

;====================== Fit button
fitb = widget_base(base,/row)
;fitb = widget_base(/row,/modal,group_leader=w_state.base)
;fitb = widget_base(/row,/floating,group_leader=w_state.base)
w_state.buttons=fitb
w_state.fit=WIDGET_BUTTON(fitb,VALUE='Prev.',uvalue='PREVIOUS')
w_state.fit=WIDGET_BUTTON(fitb,VALUE='Fit',uvalue='FIT')
w_state.fit=WIDGET_BUTTON(fitb,VALUE='Plot',uvalue='PLOT_IT')
w_state.accept=WIDGET_BUTTON(fitb,VALUE='Accept',uvalue='ACCEPT')
w_state.next=WIDGET_BUTTON(fitb,VALUE='Next',uvalue='NEXT')
widget_control,w_state.buttons,default_button=w_state.fit

;====================== Display positions on the plot
posb=widget_base(fitb,/row,/frame)
xs=15
wpos1=widget_base(posb,/row)
toto = widget_label(wpos1,value = "V=")
w_state.vpos =  widget_text(wpos1,/editable,uvalue = 'VPOS', xsize = xs, $
                     value=string(0.,format=frmt3))
wpos2=widget_base(posb,/row)
toto = widget_label(wpos2,value = "T=")
w_state.tpos =  widget_text(wpos2,/editable,uvalue = 'TPOS', xsize = xs, $
                     value=string(0.,format=frmt3))

;====================== Autot Save
fitbb=widget_base(fitb,/row,/frame)
wsave=widget_base(fitbb,/nonexclusive)
toto = widget_label(fitbb,value = "Save in:")
w_state.autosave=WIDGET_BUTTON(wsave,VALUE='',uvalue='AUTOSAVE')
w_state.filename =  widget_text(fitbb,/editable,uvalue = 'FNAME', $
                     xsize = 20, $
                     value=v_state.outfile)
widget_control,w_state.autosave,set_button=0
widget_control,w_state.filename,sensitive=0
v_state.autosave=0

w_control = widget_base(base,/row,/frame)

;====================== i,j Slider + plot_it button
w_control1 = widget_base(w_control,/column,/frame)
w_scale_title  = WIDGET_LABEL(w_control1,value='Position')

v_state.ivalue=ipos
w_state.islider = WIDGET_SLIDER(w_control1, $
                               MINIMUM = 0, MAXIMUM = Nx-1, $
                               VALUE  = v_state.ivalue, $
                               uvalue = 'ISLIDER')
v_state.jvalue=jpos
w_state.jslider = WIDGET_SLIDER(w_control1, $
                               MINIMUM = 0, MAXIMUM = Ny-1, $
                               VALUE  = v_state.jvalue, $
                               uvalue = 'JSLIDER')
v_state.plot_it=1
wp=widget_base(w_control1,/row)
wplot=widget_base(wp,/exclusive)
w_state.ifirst=WIDGET_BUTTON(wplot,VALUE='i first',uvalue='IFIRST')
w_state.jfirst=WIDGET_BUTTON(wplot,VALUE='j first',uvalue='JFIRST')
widget_control,w_state.jfirst,/set_button
v_state.ifirst=0

;====================== components
xss=9
w_control0 = widget_base(w_control,/column,/frame)
w = widget_label(w_control0,value = "Components")
w_state.ncompo =  widget_text(w_control0,/editable, $
                         uvalue = 'NCOMPO',xsize = xss, $
                         value=strtrim(v_state.ncompo,2))
;============================== Slider Showing current Component
w_control3 = widget_base(w_control0,/column)
v_state.compo_number=1
IF v_state.ncompo GT 1 THEN BEGIN
  w_state.compo_number = WIDGET_SLIDER(w_control3, $
                               MINIMUM = 1, MAXIMUM = v_state.ncompo, $
                               VALUE  = v_state.compo_number, $
                               uvalue = 'COMPOSLIDER')
ENDIF ELSE BEGIN
  w_state.compo_number = WIDGET_SLIDER(w_control3, $
                               MINIMUM = 1, MAXIMUM = 2, $
                               VALUE  = v_state.compo_number, $
                               uvalue = 'COMPOSLIDER')
  widget_control,w_state.compo_number,sensitive=0
ENDELSE
;=============================== Button to get values from reference save set
wbb3=widget_base(w_control0,/row,/nonexclusive)
w_state.fromref = WIDGET_BUTTON(wbb3,value='From Ref.',UVALUE = 'FROMREF')
widget_control,w_state.fromref,set_button=0


;====================== Parameters to be fitted for each component
xs=15
w_control5 = widget_base(w_control,/column,/frame)
w = widget_label(w_control5,value = 'Fit')
vv=im_state.fix_values(0)
wb1=widget_base(w_control5,/row)
;w = widget_label(wb1,value = 'Tr')
wbb1=widget_base(wb1,/row,/nonexclusive)
w_state.fixtr = WIDGET_BUTTON(wbb1,value='Tr:',UVALUE = 'FIXTR')
widget_control,w_state.fixtr,set_button=1

w_state.Tfixed=widget_text(wb1,/editable,uvalue = 'TFIXED',xsize = xs, $
                         value=string(strtrim(vv,2),format=frmt3))
widget_control,w_state.Tfixed,sensitive=0                        

wb2=widget_base(w_control5,/row)
;w = widget_label(wb2,value = ' V')
wbb2=widget_base(wb2,/row,/nonexclusive)
w_state.fixv = WIDGET_BUTTON(wbb2,value='V:',UVALUE = 'FIXV')
widget_control,w_state.fixv,set_button=1
vv=im_state.fix_values(0+1)
w_state.Vfixed=widget_text(wb2,/editable,uvalue = 'VFIXED',xsize = xs, $
                         value=string(strtrim(vv,2),format=frmt3))
widget_control,w_state.Vfixed,sensitive=0     

wb3=widget_base(w_control5,/row)
;w = widget_label(wb3,value = 'dV')
wbb3=widget_base(wb3,/row,/nonexclusive)
w_state.fixdv = WIDGET_BUTTON(wbb3,value='dV:',UVALUE = 'FIXDV')
widget_control,w_state.fixdv,set_button=1
vv=im_state.fix_values(0+2)
w_state.dVfixed=widget_text(wb3,/editable,uvalue = 'DVFIXED',xsize = xs, $
                         value=string(strtrim(vv,2),format=frmt3))
widget_control,w_state.dVfixed,sensitive=0     

wb4=widget_base(w_control5,/row)
wbb4=widget_base(wb4,/row,/exclusive,/frame)
w_state.autofit = WIDGET_BUTTON(wbb4,value='Auto',UVALUE = 'AUTOFIT')
w_state.stopautofit = WIDGET_BUTTON(wbb4,value='Stop',UVALUE = 'STOPAUTOFIT')
widget_control,w_state.stopautofit,set_button=1

;====================== vrange & trange
w_control2 = widget_base(w_control,/column,/frame)
w = widget_label(w_control2,value = "Vrange")
xs=15

ww1=widget_base(w_control2,/row)
v_state.vrange(0)=-10.
w_state.vmin =  widget_text(ww1,/editable, $
                         uvalue = 'VMIN',xsize = xs, $
                         value=string(strtrim(v_state.vrange(0),2),format=frmt3))
ww1b=widget_base(ww1,/nonexclusive)                       
toto = WIDGET_BUTTON(ww1b,value='',UVALUE = 'FIXVMIN')

                      
ww2=widget_base(w_control2,/row)                            
v_state.vrange(1)=10.
w_state.vmax =  widget_text(ww2,/editable, $
                         uvalue = 'VMAX',xsize = xs, $
                         value=string(strtrim(v_state.vrange(1),2),format=frmt3))
ww2b=widget_base(ww2,/nonexclusive)                                                
toto = WIDGET_BUTTON(ww2b,value='',UVALUE = 'FIXVMAX')
                         
                         
w_control3 = widget_base(w_control,/column,/frame)
w = widget_label(w_control3,value = "Trange")
ww3=widget_base(w_control3,/row)
v_state.Trange(0)=-1.
w_state.Tmin =  widget_text(ww3,/editable, $
                         uvalue = 'TMIN',xsize = xs, $
                         value=string(strtrim(v_state.trange(0),2),format=frmt3))
ww3b=widget_base(ww3,/nonexclusive)                            
toto = WIDGET_BUTTON(ww3b,value='',UVALUE = 'FIXTMIN')

ww4=widget_base(w_control3,/row)                                                  
v_state.Trange(1)=10.
w_state.Tmax =  widget_text(ww4,/editable, $
                         uvalue = 'TMAX',xsize = xs, $
                         value=string(strtrim(v_state.trange(1),2),format=frmt3))
ww4b=widget_base(ww4,/nonexclusive)                         
toto = WIDGET_BUTTON(ww4b,value='',UVALUE = 'FIXTMAX')

;============================== rebin and baseline
w_control4 = widget_base(w_control,/column,/frame)
w = widget_label(w_control4,value = "Rebin")
v_state.rebin=1
w_state.rebin =  widget_text(w_control4,/editable, $
                         uvalue = 'REBIN',xsize = xs, $
                         value=string(strtrim(v_state.rebin,2),format=frmt2))
v_state.base_degree=2
v_state.baseline=1
xss=5
wb4=widget_base(w_control4,/row)
w = widget_label(wb4,value = 'Baseline:')
wbb4=widget_base(wb4,/row,/nonexclusive)
w_state.baseline = WIDGET_BUTTON(wbb4,value='',UVALUE = 'BASELINE')
widget_control,w_state.baseline,set_button=v_state.baseline,sensitive=0
w_state.base_degree=widget_text(wb4,/editable,uvalue = ' BASE_DEGREE',xsize = xss, $
                         value=string(strtrim(v_state.base_degree,2)))
widget_control,w_state.base_degree,sensitive=0     

toto=WIDGET_BUTTON(wb4,VALUE='Reset',uvalue='RESET_BASELINE')

;============================== widget text for messages
label_message = widget_label(w_state.base,value = "Messages :")
w_state.tex_mess = widget_text(w_state.base,xsize=45)

;============================== Initialize a few variables
IF !version.os EQ 'MacOS' THEN BEGIN
  v_state.previous_path='Macintosh HD:Data:NCS:45M:'
  v_state.previous_save_path='Macintosh HD:Data:NCS:45M:'
ENDIF
IF !version.os EQ 'sunos' THEN BEGIN
  v_state.previous_path='/dd00/bernard2/data/NCS/45M/'
  v_state.previous_save_path='/dd00/bernard2/data/NCS/45M/'
ENDIF
v_state.filter='*.fits'
v_state.save_filter='*.xdr'

;============================= Realize the widget
widget_control,base,/realize
widget_control,w_state.buttons,/realize
;============================= Get window number
widget_control,w_state.draw,get_value=vv
v_state.window=vv

;============================= set the widget state structure
state={widgets:w_state,var:v_state,ims:im_state}

;============================= put state in Child1
widget_control,child1,set_uvalue=state

xmanager,'fit_spectra',w_state.base,/no_block, $
         event_handler='fit_spectra_event'
         
sortie:

end                              
  

