PRO fit_spectra_event,ev

;=========== Get first child number
child1=widget_info(ev.handler,/child)
;print,'child1============',child1
;help,ev,/str
;stop

;=========== Get the state structure
widget_control,child1,get_uvalue=state,/no_copy
;=========== get widget numbers
mess=state.widgets.tex_mess

;=========== Get user value of the event
;eventval=1
widget_control,ev.id,get_uvalue = eventval
IF  NOT defined(eventval) THEN BEGIN
  eventval='BAR'
ENDIF
parent=widget_info(ev.id,/parent)
IF parent EQ state.widgets.fbl THEN BEGIN
  eventval='BAR'
ENDIF
;print,'Event user value =',eventval
;help,ev,/str

frmt3=state.var.frmt3

;IF state.var.bar EQ 0 THEN which='BAR' LESE which
CASE eventval  OF
    
;    'FILE' : BEGIN
    'BAR':BEGIN
        CASE ev.value OF
            'Open Data File (Fits) ...': BEGIN
               file=pickfile(get_path=previous_path, $
                      path=state.var.previous_path,/read, $
                      filter=state.var.filter)
               IF file NE '' THEN BEGIN
                 state.var.previous_path=previous_path
                 widget_control,mess,set_value = 'Reading fits file '+file
                 d=readfits(file,h)
;                 stop
                 IF strtrim(sxpar(h,'BUNIT'),2) EQ 'K km/s' THEN BEGIN
                   d=d/sxpar(h,'CDELT3')
                   text = 'K km/s detected ... deviding by cdelt3'
                   widget_control,mess,set_value = text
                 ENDIF
;                 h=fix_45m_header(h)
                 h=fix_nanten_header(h)
                 create_coo2,h,coo1,coo2,/silent
                 si=size(d)
                 Nx=si(1) & Ny=si(2) & Nz=si(3)
                 state.var.Nx=Nx & state.var.Ny=Ny & state.var.Nz=Nz
                 ;=== Create the saving cube for the new dataset
                 widget_control,mess,set_value = 'Creating save cube ...'
                 all_T=fltarr(Nx,Ny,state.var.ncompo+1)+!indef
                 all_v=all_T & all_dv=all_v
                 all_T_fitted=intarr(Nx,Ny,state.var.ncompo+1)+fix(!indef)
                 all_v_fitted=all_T_fitted & all_dv_fitted=all_v_fitted
                 coef=fltarr(3*state.var.ncompo)+!indef
                 ;=== Update the slider upper bound
                 widget_control,state.widgets.islider,set_slider_max=Nx-1
                 widget_control,state.widgets.jslider,set_slider_max=Ny-1
                 spec=reform(d(state.var.ivalue,state.var.jvalue,*))
                 vel=(indgen((size(spec))(1))-sxpar(h,'CRPIX3'))* $
                      sxpar(h,'cdelt3')+sxpar(h,'crval3')
                 widget_control,mess,set_value = 'Updating data  ...'
                 set_state_cube,state,cube=d,header=h, $
                        spectrum=spec,velocity=vel, $
                        all_T=all_T,all_v=all_v,all_dv=all_dv, $
                        all_fitted_T=all_T_fitted,all_fitted_v=all_v_fitted, $
                        all_fitted_dv=all_dv_fitted, $
                        coef=coef,coo1=coo1,coo2=coo2
                 widget_control,mess,set_value = 'Plotting Spectrum ...'
                 update_state_range,state
                 wset,state.var.window
                 plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin
                  widget_control,mess,set_value = 'Done.'    
              ENDIF ELSE BEGIN
                widget_control,mess,set_value = 'No file Opened'
              ENDELSE
            END
            'Save Fit Params ...':BEGIN
                 file=pickfile(get_path=previous_save_path, $
                      path=state.var.previous_save_path,/write, $
                      filter=state.var.save_filter)
                 IF file NE '' THEN BEGIN
                   state.var.previous_save_path=previous_save_path
                   IF file NE previous_save_path THEN BEGIN
                      ok = strpos(file,previous_save_path)
                      if ok eq -1 then begin
                         file=previous_save_path+file 
                      endif
                      all_T=state.ims.all_T
                      all_v=state.ims.all_v
                      all_dv=state.ims.all_dv
                      all_T_fitted=state.ims.all_T_fitted
                      all_v_fitted=state.ims.all_v_fitted
                      all_dv_fitted=state.ims.all_dv_fitted
                      header=state.ims.header
                      save,all_T,all_v,all_dv, $
                           all_T_fitted,all_v_fitted,all_dv_fitted, $
                           header,file=file,/xdr
                      text = 'File '+file+' written'
                      widget_control,mess,set_value = text
                    ENDIF ELSE BEGIN
                      text = 'No file written'
                      widget_control,mess,set_value = text
                    ENDELSE
                ENDIF ELSE BEGIN
                    text = 'No file written'
                    widget_control,mess,set_value = text
                ENDELSE
            END
            'Restore Fit Params ...':BEGIN
                 file=pickfile(get_path=previous_save_path, $
                      path=state.var.previous_save_path,/read, $
                      filter=state.var.save_filter)
                 IF file NE '' THEN BEGIN
                   state.var.previous_save_path=previous_save_path
                   IF file NE previous_save_path THEN BEGIN
                      ok = strpos(file,previous_save_path) 
                      if ok eq -1 then begin 
                         file=previous_save_path+file 
                      endif               
                      restore,file
                      create_coo2,header,coo1,coo2,/silent
                      set_state_cube,state, $
                          all_T=all_T,all_v=all_v,all_dv=all_dv, $
                          all_fitted_T=all_T_fitted, $
                          all_fitted_v=all_v_fitted, $
                          all_fitted_dv=all_dv_fitted, $
                          header=header,coo1=coo1,coo2=coo2
                      text = 'File '+file+' has been read.'
                      widget_control,mess,set_value = text
                      si=size(all_T) & ncompo_max=si(3)-1
                      state.var.ncompo_max=ncompo_max
                      widget_control,state.widgets.filename,set_value=file
                    ENDIF ELSE BEGIN
                      text = 'No file Read'
                      widget_control,mess,set_value = text
                    ENDELSE
                 ENDIF ELSE BEGIN
                   text = 'No file Read'
                   widget_control,mess,set_value = text
                 ENDELSE
            END
            'Restore Reference Fit Params ...':BEGIN
                 file=pickfile(get_path=previous_save_path, $
                      path=state.var.previous_save_path,/read, $
                      filter=state.var.save_filter)
                 IF file NE '' THEN BEGIN
                   state.var.previous_save_path=previous_save_path
                   IF file NE previous_save_path THEN BEGIN
                      ok = strpos(file,previous_save_path) 
                      if ok eq -1 then begin 
                         file=previous_save_path+file 
                      endif               
                      restore,file
                      create_coo2,header,coo1_ref,coo2_ref,/silent
                      set_state_cube,state, $
                          Rall_T=all_T,Rall_v=all_v,Rall_dv=all_dv, $
                          Rall_fitted_T=all_T_fitted, $
                          Rall_fitted_v=all_v_fitted, $
                          Rall_fitted_dv=all_dv_fitted, $
                          Rheader=header,Rcoo1=coo1_ref,Rcoo2=coo2_ref
                      text = 'Reference File '+file+' has been read.'
                      widget_control,mess,set_value = text
                      si=size(all_T) & ncompo_max=si(3)-1
                      state.var.ncompo_max=ncompo_max
                      widget_control,state.widgets.filename,set_value=file
                    ENDIF ELSE BEGIN
                      text = 'No Refernece File Read'
                      widget_control,mess,set_value = text
                    ENDELSE
                 ENDIF ELSE BEGIN
                   text = 'No Reference File Read'
                   widget_control,mess,set_value = text
                 ENDELSE
            END
            'Print' : BEGIN
                 selection=ev.name
                 IF selection EQ 'poscript file' THEN BEGIN
                    postcript=state.var.outfile
                 ENDIF 
                 text = 'Printing the plot ...'
                 widget_control,mess,set_value = text

                 ;must do it here

                 text = 'Printing Done'
        
                 widget_control,mess,set_value = text
            END
            'Quit'  : BEGIN
                  widget_control,ev.top,/destroy
                  RETURN
             END
           'Header Info' : BEGIN
                 xhprint,state.ims.header
            END
            ELSE : BEGIN
;                  stop
                 str=ev.value
                 kind=strmid(str,0,strlen(str)-1)
                 compo=fix(strmid(str,strlen(str)-1,1))
                 IF compo LE state.var.ncompo_max THEN BEGIN
                   CASE kind OF
                      'T':BEGIN
                           data=state.ims.all_T(*,*,compo-1)
                           title='Tr (K) component #'+strtrim(compo,2)
                      END
                      'V':BEGIN
                            data=state.ims.all_V(*,*,compo-1)
                            title='V (km/s) component #'+strtrim(compo,2)
                     END
                     'D':BEGIN
                            data=state.ims.all_DV(*,*,compo-1)
                            title='dV (km/s) component #'+strtrim(compo,2)
                     END
                     'TdV':BEGIN
                            Tr=state.ims.all_T(*,*,compo-1)
                            dV=state.ims.all_DV(*,*,compo-1)
                            data=Tr
                            data(*,*)=!indef
                            ind=where(Tr NE !indef AND dV NE !indef,count)
                            IF count NE 0 THEN BEGIN
                              data(ind)=Tr(ind)*ABS(dV(ind))
                            ENDIF
                            title='Tr*dV (K km/s) component #'+strtrim(compo,2)
                     END
                   ENDCASE
                   header=state.ims.header
                    imcont21,bidon,data=data,header=header,title=title
                  wset,state.var.window
               ENDIF ELSE BEGIN
                   text='Component not in dataset ...'
                   widget_control,mess,set_value = text
               ENDELSE
            END          
         ENDCASE
     END
     
     'AUTOSAVE':BEGIN
         state.var.autosave=ev.select
         IF ev.select EQ 1 THEN BEGIN
            widget_control,state.widgets.filename,/sensitive 
         ENDIF ELSE BEGIN 
            widget_control,state.widgets.filename,sensitive=0
            widget_control,state.widgets.filename,set_value=''
         ENDELSE
     END
     'TMIN':BEGIN
         frmt=state.var.frmt3
         widget_control,state.widgets.tmin,get_value=vv
         state.var.trange(0)=vv
         widget_control,state.widgets.tmin,set_value=string(vv,format=frmt)
     END
     'TMAX':BEGIN
         frmt=state.var.frmt3
         widget_control,state.widgets.tmax,get_value=vv
         state.var.trange(1)=vv
         widget_control,state.widgets.tmax,set_value=string(vv,format=frmt)
     END
     'VMIN':BEGIN
         frmt=state.var.frmt3
         widget_control,state.widgets.vmin,get_value=vv
         state.var.vrange(0)=vv
         widget_control,state.widgets.vmin,set_value=string(vv,format=frmt)
     END
     'VMAX':BEGIN
         frmt=state.var.frmt3
         widget_control,state.widgets.vmax,get_value=vv
         state.var.vrange(1)=vv
         widget_control,state.widgets.vmax,set_value=string(vv,format=frmt)
     END
    'FIT':BEGIN
        fit_one_spectrum,state
     END
    'ACCEPT':BEGIN
        accept_new_fit_values,state        
    END
    'ADOPT':BEGIN
        widget_control,state.widgets.bestfit,get_value=bfit
        compo=state.var.compo_number
        ncompo_max=state.var.ncompo_max
        frmt=state.var.frmt3
        CASE ev.value OF
            'This Components':BEGIN
                print,'Not used yet ...'
            END
            'All Components':BEGIN
                coef=state.ims.fix_values
                FOR i=0,ncompo_max-1 DO BEGIN
                  IF strmid(bfit(0,i),0,1) NE '*' THEN coef(3*i)=bfit(0,i)
                  IF strmid(bfit(1,i),0,1) NE '*' THEN coef(3*i+1)=bfit(1,i)
                  IF strmid(bfit(2,i),0,1) NE '*' THEN coef(3*i+2)=bfit(2,i)
                  IF i+1 EQ compo THEN BEGIN
                    widget_control,state.widgets.tfixed, $
                                   set_value=string(coef(3*i),format=frmt)
                    widget_control,state.widgets.vfixed, $
                                   set_value=string(coef(3*i+1),format=frmt)
                    widget_control,state.widgets.dvfixed, $
                                   set_value=string(coef(3*i+2),format=frmt)
                  ENDIF
                ENDFOR
;                stop
                state.ims.fix_values=coef
                
            END
        ENDCASE
    END
    'RESET':BEGIN
        i=state.var.ivalue & j=state.var.jvalue
        state.ims.all_T(i,j,*)=!indef
        state.ims.all_V(i,j,*)=!indef
        state.ims.all_dV(i,j,*)=!indef
        state.ims.all_T_fitted(i,j,*)=1
        state.ims.all_V_fitted(i,j,*)=1
        state.ims.all_dV_fitted(i,j,*)=1
        update_fit_table,state
    END
    'FITTED_TABLE':BEGIN
        help,ev,/str
    END
    'IFIRST':BEGIN
        IF state.var.ifirst EQ 0 THEN state.var.ifirst=1 ELSE $
                                      state.var.ifirst=0
    END
    'NEXT':BEGIN
        goto_next_spectrum,state,/plot
    END
    'PREVIOUS':BEGIN
        goto_next_spectrum,state,/previous,/plot
    END
    
    'PLOT_IT':BEGIN
        state.var.plot_it=ev.select
        IF ev.select  EQ 1 THEN BEGIN
          spec=reform(state.ims.cube(state.var.ivalue,state.var.jvalue,*))
;          set_state_cube,state,spectrum=spec
          state.ims.spectrum=spec
          update_state_range,state
          get_fit_params,state,fit_params
          get_baseline_params,state,baseline_vel,baseline_degree
          widget_control,mess,set_value = 'Plotting Spectrum ...'
          wset,state.var.window
          plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin,fit_params=fit_params, $
                      show_vel=state.ims.baseline,baseline_vel=baseline_vel, $
                      baseline_degree=baseline_degree
           widget_control,mess,set_value = 'Done.'           
           ;=== reset compo slider to initial value
           vv=1           
           update_compo_slider,state,vv
           ;=== Update the table of fitted parameters
           update_fit_table,state
        ENDIF
    END
    'ISLIDER':BEGIN
        state.var.ivalue=ev.value
        IF state.var.plot_it EQ 1 THEN BEGIN
          spec=reform(state.ims.cube(state.var.ivalue,state.var.jvalue,*))
          state.ims.spectrum=spec
;          set_state_cube,state,spectrum=spec
          wset,state.var.window
          update_state_range,state
          get_fit_params,state,fit_params
          get_baseline_params,state,baseline_vel,baseline_degree
          widget_control,mess,set_value = 'Plotting Spectrum ...'
          wset,state.var.window
          plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin,fit_params=fit_params, $
                      show_vel=state.ims.baseline,baseline_vel=baseline_vel, $
                      baseline_degree=baseline_degree
           widget_control,mess,set_value = 'Done.'           
           ;=== reset compo slider to initial value
           vv=1           
           update_compo_slider,state,vv
           ;=== Update the table of fitted parameters
           update_fit_table,state
        ENDIF              
        IF state.var.fromref EQ 1 THEN BEGIN
            get_ref_values,state
        ENDIF
    END  
    'JSLIDER':BEGIN   
        state.var.jvalue=ev.value
        IF state.var.plot_it EQ 1 THEN BEGIN
           spec=reform(state.ims.cube(state.var.ivalue,state.var.jvalue,*))
           state.ims.spectrum=spec
           update_state_range,state
           get_fit_params,state,fit_params
           get_baseline_params,state,baseline_vel,baseline_degree
           widget_control,mess,set_value = 'Plotting Spectrum ...'
           wset,state.var.window
           plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin,fit_params=fit_params, $
                      show_vel=state.ims.baseline,baseline_vel=baseline_vel, $
                      baseline_degree=baseline_degree
            widget_control,mess,set_value = 'Done.'           
            ;=== reset compo slider to initial value
           vv=1           
           update_compo_slider,state,vv
           ;=== Update the table of fitted parameters
           update_fit_table,state
        ENDIF                         
        IF state.var.fromref EQ 1 THEN BEGIN
            get_ref_values,state
        ENDIF
    END  
    "FNAME" : BEGIN
        widget_control,ev.id,get_value = state.var.outfile
        text='Filename set to '+string(state.var.outfile)
        widget_control,mess,set_value = text
    END
    'BASELINE':BEGIN
        IF ev.select EQ 1 THEN state.var.baseline = 1
        IF ev.select EQ 0 THEN state.var.baseline = 0
    END
    'BASE_DEGREE':BEGIN
         frmt='(I2)'
         widget_control,state.widgets.base_degree,get_value=vv
         state.var.base_degree=vv
         widget_control,state.widgets.base_degree, $
                        set_value=string(vv,format=frmt)
    END
    'RESET_BASELINE':BEGIN
        baseline=fltarr(1,2) & baseline(*,*)=!indef
        set_state_cube,state,baseline=baseline
        get_baseline_params,state,baseline_vel,baseline_degree
        get_fit_params,state,fit_params
        plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin,fit_params=fit_params, $
                      show_vel=state.ims.baseline
    END
    'DRAW':BEGIN
        last_press=state.var.last_press
        last_release=state.var.last_release
        last_clicks=state.var.last_clicks
;        print,ev.x,ev.y,ev.press,ev.release,ev.clicks
        ;=== Convert from window coordinates to plot coordinates
        xscale=!x.crange(1)-!x.crange(0)
        xoff=!x.crange(0)
        xv=(1.*ev.x/!d.x_size-!x.window(0))/ $
              (!x.window(1)-!x.window(0))*xscale+xoff
        yscale=!y.crange(1)-!y.crange(0)
        yoff=!y.crange(0)
        yv=(1.0*ev.y/!d.y_vsize-!y.window(0))/ $
                 (!y.window(1)-!y.window(0))*yscale+yoff
        ;=== reflect in corresponding widget
        widget_control,state.widgets.vpos, $
                       set_value=string(xv,format=state.var.frmt3)
        widget_control,state.widgets.tpos, $
                       set_value=string(yv,format=state.var.frmt3)

        IF ev.release EQ 1 THEN BEGIN
          IF last_press EQ 1 THEN BEGIN
;            stop
            ;=== set the initial parameters for the fit
            compo=state.var.compo_number
            control=state.ims.to_be_fitted(3*(compo-1))
            IF control EQ 1 THEN BEGIN
              state.ims.coef(3*(compo-1))=yv
            ENDIF ELSE BEGIN
              widget_control,state.widgets.Tfixed,get_value=yval
              state.ims.coef(3*(compo-1))=yval
            ENDELSE
            control=state.ims.to_be_fitted(3*(compo-1)+1)
            IF control EQ 1 THEN BEGIN
              state.ims.coef(3*(compo-1)+1)=xv
            ENDIF ELSE BEGIN
              widget_control,state.widgets.vfixed,get_value=xval
              state.ims.coef(3*(compo-1)+1)=xval
            ENDELSE
            control=state.ims.to_be_fitted(3*(compo-1)+2)
            IF control EQ 1 THEN BEGIN
              state.ims.coef(3*(state.var.compo_number-1)+2)=0.5
            ENDIF ELSE BEGIN
              widget_control,state.widgets.dvfixed,get_value=val
              state.ims.coef(3*(state.var.compo_number-1)+2)=val
            ENDELSE
            ;=== Generate the first Guess Gaussian
            vel=state.ims.velocity
            coef=state.ims.coef
            j=state.var.compo_number-1
            f=generate_gaussian(1,vel,coef(3*j:3*j+2))
            oplot,vel,f,color=100
            ;=== oplot buttons to change Dv, if necessary
            IF state.ims.to_be_fitted(3*j+2) EQ 0 THEN BEGIN
               yv=max(f)/2.
               xv=interpol(vel,f,yv)
               oplot,[xv],[yv],psym=4,color=100
            ENDIF
            IF state.var.compo_number NE state.var.ncompo THEN BEGIN
              state.var.compo_number=state.var.compo_number+1
            ENDIF ELSE BEGIN
              state.var.compo_number=1
            ENDELSE
            vv=state.var.compo_number
            update_compo_slider,state,vv
           ENDIF
          goto,no_drag
          ;This is the drag detection option
          IF last_press EQ 0 AND last_release EQ 0  $
             AND last_clicks EQ 0 THEN BEGIN  
            ;=== Convert from window coordinates to plot coordinates
            xscale=!x.crange(1)-!x.crange(0)
            xoff=!x.crange(0)
            xv=(1.*ev.x/!d.x_size-!x.window(0))/ $
              (!x.window(1)-!x.window(0))*xscale+xoff
            yscale=!y.crange(1)-!y.crange(0)
            yoff=!y.crange(0)
            yv=(1.0*ev.y/!d.y_vsize-!y.window(0))/ $
                 (!y.window(1)-!y.window(0))*yscale+yoff
            dV=ABS(state.ims.coef(3*(state.var.compo_number-1)+1)-xv)
            state.ims.coef(3*(state.var.compo_number-1)+2)=dV
            vel=state.ims.velocity
            coef=state.ims.coef
            j=state.var.compo_number-1
            f=generate_gaussian(1,vel,coef(3*j:3*j+2))
            oplot,vel,f,color=100
          ENDIF
          no_drag:
        ENDIF ELSE BEGIN
           ;define limits for baseline fitting
          IF ev.release EQ 2 THEN BEGIN
             baseline=state.ims.baseline
             Nbas=(size(baseline))(1)
             newbaseline=fltarr(Nbas+1,2)
             newbaseline(*)=!indef
             newbaseline(0:Nbas-1,*)=baseline
             newbaseline(Nbas,0)=xv
             set_state_cube,state,baseline=newbaseline
             plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin,show_vel=state.ims.baseline
             ind=where(state.ims.baseline(*,0) NE !indef AND state.ims.baseline(*,1) NE !indef,count)
             IF count GT 1 THEN BEGIN
               widget_control,state.widgets.baseline,sensitive=1,set_button=1
               widget_control,state.widgets.base_degree,sensitive=1
             ENDIF ELSE BEGIN
               widget_control,state.widgets.baseline,sensitive=0
               widget_control,state.widgets.base_degree,sensitive=0
             ENDELSE                      
          ENDIF
          IF ev.release EQ 4 THEN BEGIN
             baseline=state.ims.baseline
             Nbas=(size(baseline))(1)
             newbaseline=baseline
             newbaseline(Nbas-1,1)=xv
             set_state_cube,state,baseline=newbaseline
             plot_fit_spec,state.ims.velocity,state.ims.spectrum, $
                      vrange=state.var.vrange,trange=state.var.trange, $
                      rebin=state.var.rebin,show_vel=state.ims.baseline
             ind=where(state.ims.baseline(*,0) NE !indef AND state.ims.baseline(*,1) NE !indef,count)
             IF count GT 1 THEN BEGIN
               widget_control,state.widgets.baseline,sensitive=1
               widget_control,state.widgets.base_degree,sensitive=1
             ENDIF ELSE BEGIN
               widget_control,state.widgets.baseline,sensitive=0,set_button=1
               widget_control,state.widgets.base_degree,sensitive=0
             ENDELSE                      
;             stop
          ENDIF
          
;          help,ev,/str
          state.var.last_press=ev.press
          state.var.last_release=ev.release
          state.var.last_clicks=ev.clicks
        ENDELSE
    END
    'FIXVMIN':BEGIN
        state.var.vmin_fixed=ev.select
    END
    'FIXVMAX':BEGIN
        state.var.vmax_fixed=ev.select
    END
    'FIXTMIN':BEGIN
        state.var.tmin_fixed=ev.select
    END
    'FIXTMAX':BEGIN
        state.var.tmax_fixed=ev.select
    END
    'TFIXED':BEGIN
          compo=state.var.compo_number
         frmt=state.var.frmt3
         widget_control,state.widgets.tfixed,get_value=vv
         vv=float(vv(0))
         widget_control,state.widgets.tfixed,set_value=string(vv,format=frmt)
         state.ims.fix_values(3*(compo-1))=vv
    END
     'VFIXED':BEGIN
         compo=state.var.compo_number
         frmt=state.var.frmt3
         widget_control,state.widgets.vfixed,get_value=vv
         vv=float(vv(0))
         widget_control,state.widgets.vfixed,set_value=string(vv,format=frmt)
         state.ims.fix_values(3*(compo-1)+1)=vv
    END
     'DVFIXED':BEGIN
         compo=state.var.compo_number
         frmt=state.var.frmt3
         widget_control,state.widgets.dvfixed,get_value=vv
         vv=float(vv(0))
         widget_control,state.widgets.dvfixed,set_value=string(vv,format=frmt)
         state.ims.fix_values(3*(compo-1)+2)=vv
    END
    'NCOMPO':BEGIN
        widget_control,ev.id,get_value=v
        v=v(0)
        IF v LT 1 THEN v=1
        state.var.ncompo=v & nncompo=v
        to_be_fitted=intarr(3*v) & to_be_fitted(*)=1
        coef=fltarr(3*v)
        fix_values=fltarr(3*v) & fix_values(*)=1.
        widget_control,state.widgets.fixtr,set_button=1
        widget_control,state.widgets.fixv,set_button=1
        widget_control,state.widgets.fixdv,set_button=1
        set_state_cube,state,coef=coef,to_be_fitted=to_be_fitted, $
              fix_values=fix_values
        set_state_cube,state,all_T=all_T,all_v=all_v,all_dv=all_dv, $
              all_fitted_T=all_T_fitted,all_fitted_v=all_v_fitted, $
              all_fitted_dv=all_dv_fitted
        IF v GT 1 THEN BEGIN
           widget_control,state.widgets.compo_number,/sensitive
           widget_control,state.widgets.compo_number, $
                          set_slider_max=state.var.ncompo
        ENDIF ELSE BEGIN
           widget_control,state.widgets.compo_number,sensitive=0
        ENDELSE
    END 
    'COMPOSLIDER':BEGIN
        widget_control,state.widgets.compo_number,get_value=vv
        update_compo_slider,state,vv
    END
    'FROMREF':BEGIN
        IF state.var.fromref EQ 0 THEN state.var.fromref=1 ELSE $
                                      state.var.fromref=0
        IF state.var.fromref EQ 1 THEN BEGIN
            get_ref_values,state
        ENDIF
    END
    'REBIN':BEGIN
         frmt=state.var.frmt2
         widget_control,state.widgets.rebin,get_value=vv
         vv=fix(vv(0))
         state.var.rebin=vv
         widget_control,state.widgets.rebin,set_value=string(vv,format=frmt)
    END
    'FIXTR':BEGIN
        i=state.var.compo_number-1
        state.ims.to_be_fitted(3*i)=ev.select
        IF ev.select EQ 0 THEN BEGIN
          widget_control,state.widgets.tfixed,/sensitive
        ENDIF ELSE BEGIN
          widget_control,state.widgets.tfixed,sensitive=0
        ENDELSE
    END
    'FIXV':BEGIN
        i=state.var.compo_number-1
        state.ims.to_be_fitted(3*i+1)=ev.select
        IF ev.select EQ 0 THEN BEGIN
          widget_control,state.widgets.vfixed,/sensitive
        ENDIF ELSE BEGIN
          widget_control,state.widgets.vfixed,sensitive=0
        ENDELSE
    END
    'FIXDV':BEGIN
        i=state.var.compo_number-1
        state.ims.to_be_fitted(3*i+2)=ev.select
        IF ev.select EQ 0 THEN BEGIN
          widget_control,state.widgets.dvfixed,/sensitive
        ENDIF ELSE BEGIN
          widget_control,state.widgets.dvfixed,sensitive=0
        ENDELSE
    END
    'AUTOFIT':BEGIN
      state.var.mode='Background'
      text='Switching to Background mode ... '
      widget_control,mess,set_value = text
    END
    'STOPAUTOFIT':BEGIN
      state.var.mode='Interactive'
      text='Switching to Interactive mode ... '
      widget_control,mess,set_value = text
    END
    ELSE   : BEGIN
        print,'Unused event'
    END
    
ENDCASE

mode=state.var.mode
widget_control,child1,set_uvalue=state,/no_copy

IF mode EQ 'Interactive' THEN BEGIN
;    END
    RETURN
ENDIF ELSE BEGIN                ;Auto Fit mode
    child1=widget_info(ev.handler,/child)
    start:
    widget_control,child1,get_uvalue=state,/no_copy

; Do whatever ....
    print,'Background Mode !!!'
    goto_next_spectrum,state,/plot
    ind=where(state.ims.spectrum EQ min(state.ims.spectrum),count)
    IF count NE (size(state.ims.spectrum))(1) THEN BEGIN
      fit_one_spectrum,state
      accept_new_fit_values,state,/filter        
    ENDIF
    
; ===  Get out to check if the Stop button was pressed
    bbase=state.widgets.base
    mode=state.var.mode
    
    widget_control,child1,set_uvalue=state,/no_copy

    toto=widget_event(bbase,/nowait)
;    stop

    widget_control,child1,get_uvalue=state,/no_copy
    mode=state.var.mode
    delay=float(state.var.delay)
    widget_control,child1,set_uvalue=state,/no_copy

    print,'Mode=',mode
    IF mode EQ 'Background' THEN BEGIN
        wait,delay
        goto,start
    ENDIF ELSE BEGIN
        RETURN
    ENDELSE

ENDELSE

END


