PRO plot_fit_spec,vel,spec,vrange=vrange,Trange=Trange,rebin=rebin, $
                  fit_params=fit_params,show_vel=show_vel, $
                  baseline_vel=baseline_vel,baseline_degree=baseline_degree

xtit='!6Vlsr (km/s)' & ytit='!6T* (K)'

;margin=20./100.
margin=0.

vel_plot=vel
IF keyword_set(baseline_vel) AND keyword_set(baseline_degree) THEN BEGIN
  Nvel=(size(baseline_vel))(1)
  weight=vel & weight(*)=0.
  FOR i=0,Nvel-1 DO BEGIN
    ind=where(vel GE min([baseline_vel(i,0),baseline_vel(i,1)]) $
             AND vel LE max([baseline_vel(i,0),baseline_vel(i,1)]),count)
     IF count NE 0 THEN BEGIN
       weight(ind)=1
     ENDIF
  ENDFOR
  coef_base=polyfitw(vel,spec,weight,baseline_degree)
  spec_plot=spec-poly(vel,coef_base)
ENDIF ELSE BEGIN
  spec_plot=spec
ENDELSE

IF keyword_set(rebin) THEN BEGIN
  Nv=(size(spec))(1)
  NNv=fix(Nv/rebin)
  spec_plot=fltarr(NNv) & vel_plot=spec_plot
  FOR i=0,NNv-1 DO BEGIN
    spec_plot(i)=avg(spec(i*rebin:(i+1)*rebin-1))
    vel_plot(i)=avg(vel(i*rebin:(i+1)*rebin-1))
  ENDFOR
ENDIF

IF not keyword_set(vrange) THEN BEGIN
  sepmin=min(vel_plot) & spmax=max(vel_plot)
ENDIF ELSE BEGIN
  spmin=vrange(0) & spmax=vrange(1)
ENDELSE
xr=[spmin-(spmax-spmin)*margin,spmax+(spmax-spmin)*margin]

ind=where(vel_plot GT xr(0) AND vel_plot LT xr(1),count)
IF not keyword_set(Trange) THEN BEGIN
  yr1=minmax(spec(ind))
ENDIF ELSE BEGIN
  yr1=Trange
ENDELSE
yr=[yr1(0)-(yr1(1)-yr1(0))*margin,yr1(1)+(yr1(1)-yr1(0))*margin]

plot,vel_plot,spec_plot,xr=xr,/xsty,xtit=xtit,ytit=ytit,yr=yr,/ysty,psym=10

IF keyword_set(fit_params) THEN BEGIN
   ncompo=fix((size(fit_params))(1)/3)
   FOR ii=0,ncompo-1 DO BEGIN
     f=generate_gaussian(1,vel,fit_params(3*ii:3*ii+2))
     oplot,vel,f,color=70
   ENDFOR
   f=generate_gaussian(ncompo,vel,fit_params)
   oplot,vel,f,color=150
ENDIF

IF keyword_set(show_vel) THEN BEGIN
  Nvel=(size(show_vel))(1)
  FOR i=0,Nvel-1 DO BEGIN
    oplot,[show_vel(i,0),show_vel(i,0)],[yr(0),yr(1)],linestyle=1,color=50
    oplot,[show_vel(i,1),show_vel(i,1)],[yr(0),yr(1)],linestyle=1,color=50
  ENDFOR
ENDIF

;oplot,[vrange(0),vrange(0)],[spmin,spmax],psym=10,color=150
;oplot,[vrange(1),vrange(1)],[spmin,spmax],psym=10,color=150

END
