FUNCTION fix_radec_header,h,no_check=no_check

;+
; NAME:
;	fix_radec_header
; PURPOSE:
;    makes sure that the center of a header is not at center of a pixel
;    useful for TAN projection headers for which coordinates cannot compute at center
; CATEGORY:
;    Coordinates conversions
; CALLING SEQUENCE: 
;	header=fix_radec_header(h)
; INPUTS:
;    h = the input header
; OPTIONAL INPUT PARAMETERS:
; OUTPUTS:
;    header = modified header
; OPTIONAL OUTPUT PARAMETERS:
; ACCEPTED KEY-WORDS:
; COMMON BLOCKS:
; SIDE EFFECTS:
; RESTRICTIONS:
;    applied only to RA-TAN headers.
; PROCEDURE:
; MODIFICATION HISTORY:
;	Written Jan 31 1995 J.P. Bernard, IPAC.
;       Modified 12/07/01 to add /no_check
;-

IF N_PARAMS(0) EQ 0 THEN BEGIN
    print,'Calling Sequence: hout=fix_radec_header(hin)'
    print,'Accepted Key-words: no_check'
    GOTO,sortie
ENDIF

ctype1=sxpar(h,'CTYPE1')
ctype2=sxpar(h,'CTYPE2')
hout=h
IF not keyword_set(no_check) THEN BEGIN
  IF ctype1 NE 'RA---TAN' OR ctype2 NE 'DEC--TAN' THEN BEGIN
    message,'header not in RA---TAN. Not processed. use /no_check to bypass',/info
    goto,sortie
  ENDIF
ENDIF
crpix1=sxpar(h,'CRPIX1')
crpix2=sxpar(h,'CRPIX2')
IF crpix1-fix(crpix1) EQ 0. THEN BEGIN
  new_crpix1=crpix1+0.5
ENDIF ELSE BEGIN
  new_crpix1=crpix1
ENDELSE
IF crpix2-fix(crpix2) EQ 0. THEN BEGIN
  new_crpix2=crpix2+0.5
ENDIF ELSE BEGIN
  new_crpix2=crpix2
ENDELSE
h2pix,h,/silent
pix2coo2,new_crpix1,new_crpix2,new_crval1,new_crval2
sxaddpar,hout,'CRPIX1',new_crpix1
sxaddpar,hout,'CRPIX2',new_crpix2
sxaddpar,hout,'CRVAL1',new_crval1
sxaddpar,hout,'CRVAL2',new_crval2

RETURN,hout

sortie:

END
