FUNCTION fix_schlegel_header,hs

h=hs

;See Calabretta & Greisen

naxis1=sxpar(h,'NAXIS1')
naxis2=sxpar(h,'NAXIS2')

crpix1=sxpar(h,'CRPIX1')
crpix2=sxpar(h,'CRPIX2')
;The following is necessary to get the same values as Schlegel's routine !
; I do not know what 90 pixels stands for !
;crpix1=crpix1-90
;crpix2=crpix2-90
;sxaddpar,h,'CRPIX1',crpix1
;sxaddpar,h,'CRPIX2',crpix2

cdelt1=-180.D0*sqrt(2.D0)/!dpi/(1.D0*fix(crpix1))
cdelt2= 180.D0*sqrt(2.D0)/!dpi/(1.D0*fix(crpix2))
sxaddpar,h,'CDELT1',cdelt1
sxaddpar,h,'CDELT2',cdelt2

lam_nsgp=sxpar(hs,'LAM_NSGP')
crval1=270. & sxaddpar,h,'CRVAL1',crval1
IF lam_nsgp EQ 1 THEN BEGIN
  crval2=90.  & sxaddpar,h,'CRVAL2',crval2
  longpole=0. & sxaddpar,h,'LONPOLE',longpole ;needed to put rho-oph and Polaris at right position
ENDIF ELSE BEGIN
  crval2=-90.  & sxaddpar,h,'CRVAL2',crval2
  longpole=180. & sxaddpar,h,'LONPOLE',longpole ;needed to put rho-oph and Polaris at right position
ENDELSE
;longpole=90. & sxaddpar,h,'LONPOLE',longpole  ;See Calabretta & Greisen
;longpole=0. & sxaddpar,h,'LONPOLE',longpole ;needed to put rho-oph and Polaris at right position

cd1_1=cdelt1
cd2_2=cdelt2
cd1_2=0.
cd2_1=0.

sxaddpar,h,'CD1_1',cd1_1
sxaddpar,h,'CD1_2',cd1_2
sxaddpar,h,'CD2_1',cd2_1
sxaddpar,h,'CD2_2',cd2_2

RETURN,h
END