PRO make_axis,header,axis1,axis2,axis3

;+
; NAME:
;       make_axis
; CALLING SEQUENCE:
;       make_axis,header,axis1,[axis2[,axis3]]
; PURPOSE:
;       make 1D axis 
; INPUTS:
;       header = cube or image header
; OPTIONAL INPUT:
; ACCEPTED KEY-WORDS:
; OUTPUTS:
;       axis1, axis2, axis3
; PROCEDURE AND SUBROUTINE USED
;       
; SIDE EFFECTS:
;       ?
; MODIFICATION HISTORY:
;       written Jean-Philippe Bernard 19-Mars-93
;-

on_error,2

IF N_PARAMS(0) LT 2 THEN begin
  print,'Calling Sequence: make_axis,header,axis1[,axis2[,axis3]]'
  print,'Accepted Key-Words:  NONE'
  goto,sortie
ENDIF

bunit=sxpar(header,'BUNIT')
blank=sxpar(header,'BLANK')
bscale=sxpar(header,'BSCALE')
naxis=sxpar(header,'NAXIS')
naxis1=sxpar(header,'NAXIS1')
naxis2=sxpar(header,'NAXIS2')
naxis3=sxpar(header,'NAXIS3')
crval1=sxpar(header,'CRVAL1')
crval2=sxpar(header,'CRVAL2')
crval3=sxpar(header,'CRVAL3')
crpix1=sxpar(header,'CRPIX1')
crpix2=sxpar(header,'CRPIX2')
crpix3=sxpar(header,'CRPIX3')
cdelt1=sxpar(header,'CDELT1')
cdelt2=sxpar(header,'CDELT2')
cdelt3=sxpar(header,'CDELT3')
ctype1=strtrim(sxpar(header,'CTYPE1'),2)
ctype2=strtrim(sxpar(header,'CTYPE2'),2)
ctype3=strtrim(sxpar(header,'CTYPE3'),2)
name=strtrim(sxpar(header,'OBJECT'),2)

IF N_PARAMS(0) GE 2 THEN begin
  axis1=cdelt1*(indgen(naxis1)-(crpix1-1))+crval1
ENDIF

IF N_PARAMS(0) GE 3 THEN begin
  axis2=cdelt2*(indgen(naxis2)-(crpix2-1))+crval2
ENDIF

IF N_PARAMS(0) GE 4 THEN begin
  axis3=cdelt3*(indgen(naxis3)-(crpix3-1))+crval3
ENDIF

sortie:

END
