FUNCTION mosaique_healpix,nside,ordering=ordering,coordsys=coordsys,directory=directory,filter=filter,view=view, $
                          fwhm=fwhm,kernel_radius=kernel_radius,healpix_header=healpix_header

order='RING'  ;default value
csys='E'      ;default value
filt='*'      ;default value
win=1         ;default value
fwh=0.        ;default value
kernel_rad=0  ;default value

IF keyword_set(coordsys) THEN BEGIN
  csys=coordsys
ENDIF
IF keyword_set(ordering) THEN BEGIN
  order=ordering
ENDIF
IF order EQ 'NESTED' THEN nested=1
IF keyword_set(directory) THEN BEGIN
  dir=directory
ENDIF ELSE BEGIN
  dir=dialog_pickfile(/directory)
ENDELSE
IF keyword_set(window) THEN BEGIN
  win=window
ENDIF
IF keyword_set(fwhm) THEN BEGIN
  fwh=fwhm
ENDIF
IF keyword_set(kernel_radius) THEN BEGIN
  kernel_rad=kernel_radius
ENDIF

files=findfile(dir+filter,count=Nfiles)

healpix_header=make_healp_header(nside,coordsys=coordsys,ordering=ordering, $
                           main_header=main_header,data_sample=data_sample)

Npix=nside2npix(nside)
vec=fltarr(Npix) & vec(*)=!indef
weight=fltarr(Npix) & weight(*)=0.

IF Nfiles NE 0 THEN BEGIN
  FOR i=0L, Nfiles-1 DO BEGIN
    fits_file=files(i)
    fits_image=readfits(fits_file,fits_header)
    h2pix,fits_header,pixx,pixy,/silent
    pix2coo2,pixx,pixy,coo1,coo2,phi,theta,/silent
    coo1=0 & coo2=0
    ind=where(abs(phi) GT 180.,count)
    IF count NE 0 THEN BEGIN
      phi(ind)=!indef
      theta(ind)=!indef
    ENDIF
    healp_vec=fits2healp_JPB(fits_image,fits_header,healpix_header,elapsed_time=elapsed_time, $
              weight=healp_weight,fwhm=fwh,kernel_radius=kernel_rad,phi=phi,theta=theta)
    message,'Elapsed Time='+strtrim(elapsed_time,2)+' min',/info
;    stop
    ind=where(healp_weight NE 0,count)
    vec(ind)=(weight(ind)*vec(ind)+healp_weight(ind)*healp_vec(ind))/(weight(ind)+healp_weight(ind))
;    weight=weight+healp_weight

;    weight(ind)=weight(ind)+hweight(ind)
;    ind=where(healp_vec NE !indef and vec NE !indef,count)
;    IF count NE 0 THEN BEGIN
;      vec(ind)=(vec(ind)+healp_vec(ind))/2.
;    ENDIF
;    ind=where(healp_vec NE !indef and vec EQ !indef,count)
;    IF count NE 0 THEN BEGIN
;      vec(ind)=healp_vec(ind)
;    ENDIF
    IF keyword_set(view) THEN BEGIN
      jp_mollview,alog10(vec)>(-2),/online,window=win,nested=nested
    ENDIF
  ENDFOR
ENDIF

RETURN,vec

END
