FUNCTION rotate_fits,d,h,hout

naxis1=sxpar(h,'NAXIS1') & naxis2=sxpar(h,'NAXIS2')
cdelt1=sxpar(h,'CDELT1') & cdelt2=sxpar(h,'CDELT2')
crval1=sxpar(h,'CRVAL1') & crval2=sxpar(h,'CRVAL2')
crpix1=sxpar(h,'CRPIX1') & crpix2=sxpar(h,'CRPIX2')
theta=sxpar(h,'CROTA2')
ctheta=cos(theta/!radeg) & stheta=sin(theta/!radeg)

new_naxis1=fix(naxis1*abs(ctheta)+naxis2*abs(stheta))
new_naxis2=fix(naxis1*abs(stheta)+naxis2*abs(ctheta))

new_crpix1=crpix1*abs(ctheta)+crpix2*abs(stheta)
new_crpix2=(naxis1-crpix1)*abs(stheta)+crpix2*abs(ctheta)

hout=h
sxaddpar,hout,'NAXIS1',new_naxis1 & sxaddpar,hout,'NAXIS2',new_naxis2
sxaddpar,hout,'CRPIX1',new_crpix1 & sxaddpar,hout,'CRPIX2',new_crpix2
sxaddpar,hout,'CROTA2',0.
;stop
create_coo2,hout,c1,c2,/silent
h2pix,h,/silent
coo2pix2,c1,c2,i,j,/silent
ii=i-(crpix1-1) & jj=j-(crpix2-1)
ip=ii*ctheta-jj*stheta
jp=ii*stheta+jj*ctheta
ii=ip & jj=jp & ip=0 & jp=0
ii=ii+(crpix1-1) & jj=jj+(crpix2-1)
dd=my_bilinear2(d,ii,jj)

RETURN,dd

END
