PRO set_dist2,sep,i0,j0,k0
; Modified JPB 11-Sep-1992 for 2D arrays

;+
; NAME:
;       set_dist2
; CALLING SEQUENCE:
;       set_dist2,sep,i0,j0,k0
; PURPOSE:
;       Computes the square distance array to a center in pixels
; INPUTS:
;       sep = empty array
;       i0  = center position on 1st axis
;       j0  = center position on 2nd axis
; OPTIONAL INPUT:
;       k0  = center position on 3rd axis
; OUTPUTS:
;	   sep = array containing the square distance in pixels
; PROCEDURE AND SUBROUTINE USED
;       
; SIDE EFFECTS:
; EXAMPLE:
; MODIFICATION HISTORY:
;       written by Jean-Philippe Bernard (?) 09-92
;-

;on_error,2

IF n_params(0) LT 3  OR n_params(0) GT 4 THEN BEGIN
  print,'Calling sequence: set_dist2,sep,i0,j0[,k0]'
  goto,sortie
ENDIF
IF n_params(0) EQ 3 THEN BEGIN
  taille=2
ENDIF
IF n_params(0) EQ 4 THEN BEGIN
  taille=3
ENDIF

si=size(sep)

IF taille EQ 3 THEN BEGIN
  imax=si(1)
  jmax=si(2)
  kmax=si(3)
  for i=1,imax do begin
    for j=1,jmax do begin
      for k=1,kmax do begin
        sep(i-1,j-1,k-1)=(1.*i-i0-1)^2+(1.*j-j0-1)^2+(1.*k-k0-1)^2
      endfor
    endfor
  endfor
ENDIF ELSE BEGIN
  imax=si(1)
  jmax=si(2)
  for i=1,imax do begin
    for j=1,jmax do begin
      sep(i-1,j-1)=(1.*i-i0-1)^2+(1.*j-j0-1)^2
    endfor
  endfor
ENDELSE

sortie:
end
